mp3_module_Write_to_Data_Lines:
;mmb_3_fpi_stm32.h,86 :: 		static void Write_to_Data_Lines ( unsigned char _hi, unsigned char _lo )
; _lo start address is: 4 (R1)
; _hi start address is: 0 (R0)
; _lo end address is: 4 (R1)
; _hi end address is: 0 (R0)
; _hi start address is: 0 (R0)
; _lo start address is: 4 (R1)
;mmb_3_fpi_stm32.h,88 :: 		unsigned int tmp = GPIOE_ODR;
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
; tmp start address is: 12 (R3)
LDR	R3, [R2, #0]
;mmb_3_fpi_stm32.h,89 :: 		tmp &= 0xFF00;
AND	R2, R3, #65280
UXTH	R2, R2
; tmp end address is: 12 (R3)
;mmb_3_fpi_stm32.h,90 :: 		GPIOE_ODR = tmp | _hi;
ORR	R3, R2, R0, LSL #0
UXTH	R3, R3
; _hi end address is: 0 (R0)
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
STR	R3, [R2, #0]
;mmb_3_fpi_stm32.h,91 :: 		tmp = GPIOE_ODR;
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
; tmp start address is: 0 (R0)
LDR	R0, [R2, #0]
;mmb_3_fpi_stm32.h,92 :: 		tmp &= 0xFF00;
AND	R2, R0, #65280
UXTH	R2, R2
; tmp end address is: 0 (R0)
;mmb_3_fpi_stm32.h,93 :: 		GPIOE_ODR = tmp | _lo;
ORR	R3, R2, R1, LSL #0
UXTH	R3, R3
; _lo end address is: 4 (R1)
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
STR	R3, [R2, #0]
;mmb_3_fpi_stm32.h,94 :: 		}
L_end_Write_to_Data_Lines:
BX	LR
; end of mp3_module_Write_to_Data_Lines
mp3_module_Write_to_Data_Lines_8bit:
;mmb_3_fpi_stm32.h,96 :: 		static void Write_to_Data_Lines_8bit ( unsigned char _data )
; _data start address is: 0 (R0)
; _data end address is: 0 (R0)
; _data start address is: 0 (R0)
;mmb_3_fpi_stm32.h,98 :: 		unsigned int tmp = GPIOE_ODR;
MOVW	R1, #lo_addr(GPIOE_ODR+0)
MOVT	R1, #hi_addr(GPIOE_ODR+0)
; tmp start address is: 8 (R2)
LDR	R2, [R1, #0]
;mmb_3_fpi_stm32.h,99 :: 		tmp &= 0xFF00;
AND	R1, R2, #65280
UXTH	R1, R1
; tmp end address is: 8 (R2)
;mmb_3_fpi_stm32.h,100 :: 		GPIOE_ODR = tmp | _data;
ORR	R2, R1, R0, LSL #0
UXTH	R2, R2
; _data end address is: 0 (R0)
MOVW	R1, #lo_addr(GPIOE_ODR+0)
MOVT	R1, #hi_addr(GPIOE_ODR+0)
STR	R2, [R1, #0]
;mmb_3_fpi_stm32.h,101 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_3_fpi_stm32.h,102 :: 		asm nop;
NOP
;mmb_3_fpi_stm32.h,103 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_3_fpi_stm32.h,104 :: 		}
L_end_Write_to_Data_Lines_8bit:
BX	LR
; end of mp3_module_Write_to_Data_Lines_8bit
mp3_module_Set_Index:
;mmb_3_fpi_stm32.h,106 :: 		static void Set_Index ( unsigned short index )
; index start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; index end address is: 0 (R0)
; index start address is: 0 (R0)
;mmb_3_fpi_stm32.h,108 :: 		TFT_RS = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_RS+0)
MOVT	R1, #hi_addr(TFT_RS+0)
_SX	[R1, ByteOffset(TFT_RS+0)]
;mmb_3_fpi_stm32.h,109 :: 		Write_to_Data_Lines(0, index);
UXTB	R1, R0
; index end address is: 0 (R0)
MOVS	R0, #0
BL	mp3_module_Write_to_Data_Lines+0
;mmb_3_fpi_stm32.h,110 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_3_fpi_stm32.h,111 :: 		asm nop;
NOP
;mmb_3_fpi_stm32.h,112 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_3_fpi_stm32.h,113 :: 		}
L_end_Set_Index:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of mp3_module_Set_Index
mp3_module_Write_Command:
;mmb_3_fpi_stm32.h,115 :: 		static void Write_Command ( unsigned short cmd )
; cmd start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; cmd end address is: 0 (R0)
; cmd start address is: 0 (R0)
;mmb_3_fpi_stm32.h,117 :: 		TFT_RS = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_RS+0)
MOVT	R1, #hi_addr(TFT_RS+0)
_SX	[R1, ByteOffset(TFT_RS+0)]
;mmb_3_fpi_stm32.h,118 :: 		Write_to_Data_Lines(0, cmd);
UXTB	R1, R0
; cmd end address is: 0 (R0)
MOVS	R0, #0
BL	mp3_module_Write_to_Data_Lines+0
;mmb_3_fpi_stm32.h,119 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_3_fpi_stm32.h,120 :: 		asm nop;
NOP
;mmb_3_fpi_stm32.h,121 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_3_fpi_stm32.h,122 :: 		}
L_end_Write_Command:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of mp3_module_Write_Command
mp3_module_Write_Data:
;mmb_3_fpi_stm32.h,124 :: 		static void Write_Data ( unsigned int _data )
; _data start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
UXTH	R3, R0
; _data end address is: 0 (R0)
; _data start address is: 12 (R3)
;mmb_3_fpi_stm32.h,128 :: 		TFT_RS = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_RS+0)
MOVT	R1, #hi_addr(TFT_RS+0)
_SX	[R1, ByteOffset(TFT_RS+0)]
;mmb_3_fpi_stm32.h,129 :: 		temp = (_data>>11);
LSRS	R1, R3, #11
; temp start address is: 0 (R0)
UXTB	R0, R1
;mmb_3_fpi_stm32.h,130 :: 		temp = (temp<<3);
LSLS	R1, R0, #3
; temp end address is: 0 (R0)
; temp start address is: 16 (R4)
UXTB	R4, R1
;mmb_3_fpi_stm32.h,132 :: 		if ((temp>>7) == 1)
LSRS	R1, R4, #7
UXTB	R1, R1
CMP	R1, #1
IT	NE
BNE	L_mp3_module_Write_Data120
;mmb_3_fpi_stm32.h,134 :: 		temp += 7;
ADDS	R1, R4, #7
; temp end address is: 16 (R4)
; temp start address is: 0 (R0)
UXTB	R0, R1
; temp end address is: 0 (R0)
;mmb_3_fpi_stm32.h,135 :: 		}
IT	AL
BAL	L_mp3_module_Write_Data0
L_mp3_module_Write_Data120:
;mmb_3_fpi_stm32.h,132 :: 		if ((temp>>7) == 1)
UXTB	R0, R4
;mmb_3_fpi_stm32.h,135 :: 		}
L_mp3_module_Write_Data0:
;mmb_3_fpi_stm32.h,137 :: 		Write_to_Data_Lines_8bit(temp);
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
BL	mp3_module_Write_to_Data_Lines_8bit+0
;mmb_3_fpi_stm32.h,138 :: 		temp = (_data>>5);
LSRS	R1, R3, #5
; temp start address is: 0 (R0)
UXTB	R0, R1
;mmb_3_fpi_stm32.h,139 :: 		temp = (temp<<2);
LSLS	R1, R0, #2
; temp end address is: 0 (R0)
; temp start address is: 16 (R4)
UXTB	R4, R1
;mmb_3_fpi_stm32.h,141 :: 		if ((temp>>7) == 1)
LSRS	R1, R4, #7
UXTB	R1, R1
CMP	R1, #1
IT	NE
BNE	L_mp3_module_Write_Data121
;mmb_3_fpi_stm32.h,143 :: 		temp += 3;
ADDS	R1, R4, #3
; temp end address is: 16 (R4)
; temp start address is: 0 (R0)
UXTB	R0, R1
; temp end address is: 0 (R0)
;mmb_3_fpi_stm32.h,144 :: 		}
IT	AL
BAL	L_mp3_module_Write_Data1
L_mp3_module_Write_Data121:
;mmb_3_fpi_stm32.h,141 :: 		if ((temp>>7) == 1)
UXTB	R0, R4
;mmb_3_fpi_stm32.h,144 :: 		}
L_mp3_module_Write_Data1:
;mmb_3_fpi_stm32.h,146 :: 		Write_to_Data_Lines_8bit(temp);
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
BL	mp3_module_Write_to_Data_Lines_8bit+0
;mmb_3_fpi_stm32.h,147 :: 		temp = (_data<<3);
LSLS	R1, R3, #3
; _data end address is: 12 (R3)
; temp start address is: 12 (R3)
UXTB	R3, R1
;mmb_3_fpi_stm32.h,149 :: 		if ((temp>>7) == 1)
LSRS	R1, R3, #7
UXTB	R1, R1
CMP	R1, #1
IT	NE
BNE	L_mp3_module_Write_Data122
;mmb_3_fpi_stm32.h,151 :: 		temp += 7;
ADDS	R1, R3, #7
; temp end address is: 12 (R3)
; temp start address is: 0 (R0)
UXTB	R0, R1
; temp end address is: 0 (R0)
;mmb_3_fpi_stm32.h,152 :: 		}
IT	AL
BAL	L_mp3_module_Write_Data2
L_mp3_module_Write_Data122:
;mmb_3_fpi_stm32.h,149 :: 		if ((temp>>7) == 1)
UXTB	R0, R3
;mmb_3_fpi_stm32.h,152 :: 		}
L_mp3_module_Write_Data2:
;mmb_3_fpi_stm32.h,154 :: 		Write_to_Data_Lines_8bit(temp);
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
BL	mp3_module_Write_to_Data_Lines_8bit+0
;mmb_3_fpi_stm32.h,155 :: 		}
L_end_Write_Data:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of mp3_module_Write_Data
mp3_module_hal_display_init:
;mmb_3_fpi_stm32.h,157 :: 		static void hal_display_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,161 :: 		TFT_Set_Active( Set_Index, Write_Command, Write_Data );
MOVW	R2, #lo_addr(mp3_module_Write_Data+0)
MOVT	R2, #hi_addr(mp3_module_Write_Data+0)
MOVW	R1, #lo_addr(mp3_module_Write_Command+0)
MOVT	R1, #hi_addr(mp3_module_Write_Command+0)
MOVW	R0, #lo_addr(mp3_module_Set_Index+0)
MOVT	R0, #hi_addr(mp3_module_Set_Index+0)
BL	_TFT_Set_Active+0
;mmb_3_fpi_stm32.h,162 :: 		TFT_Init_SSD1963_Board_35( 320, 240 );
MOVS	R1, #240
MOVW	R0, #320
BL	_TFT_Init_SSD1963_Board_35+0
;mmb_3_fpi_stm32.h,163 :: 		TFT_Set_DBC_SSD1963( 255 );
MOVS	R0, #255
BL	_TFT_Set_DBC_SSD1963+0
;mmb_3_fpi_stm32.h,164 :: 		}
L_end_hal_display_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of mp3_module_hal_display_init
mp3_module_hal_touch_init:
;mmb_3_fpi_stm32.h,172 :: 		static uint8_t hal_touch_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,176 :: 		GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_6 );
MOVW	R1, #64
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_3_fpi_stm32.h,177 :: 		GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_7 );
MOVW	R1, #128
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_3_fpi_stm32.h,179 :: 		GPIOB_ODR.B6 = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
_SX	[R0, ByteOffset(GPIOB_ODR+0)]
;mmb_3_fpi_stm32.h,181 :: 		while ( GPIOB_IDR.B7 == 0 )
L_mp3_module_hal_touch_init3:
MOVW	R0, #lo_addr(GPIOB_IDR+0)
MOVT	R0, #hi_addr(GPIOB_IDR+0)
_LX	[R0, ByteOffset(GPIOB_IDR+0)]
CMP	R0, #0
IT	NE
BNE	L_mp3_module_hal_touch_init4
;mmb_3_fpi_stm32.h,183 :: 		GPIOB_ODR.B6 = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
_SX	[R0, ByteOffset(GPIOB_ODR+0)]
;mmb_3_fpi_stm32.h,184 :: 		Delay_us( 10 );
MOVW	R7, #398
MOVT	R7, #0
NOP
NOP
L_mp3_module_hal_touch_init5:
SUBS	R7, R7, #1
BNE	L_mp3_module_hal_touch_init5
NOP
NOP
NOP
;mmb_3_fpi_stm32.h,185 :: 		GPIOB_ODR.B6 = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
_SX	[R0, ByteOffset(GPIOB_ODR+0)]
;mmb_3_fpi_stm32.h,186 :: 		Delay_us( 10 );
MOVW	R7, #398
MOVT	R7, #0
NOP
NOP
L_mp3_module_hal_touch_init7:
SUBS	R7, R7, #1
BNE	L_mp3_module_hal_touch_init7
NOP
NOP
NOP
;mmb_3_fpi_stm32.h,187 :: 		}
IT	AL
BAL	L_mp3_module_hal_touch_init3
L_mp3_module_hal_touch_init4:
;mmb_3_fpi_stm32.h,189 :: 		I2C1_Init_Advanced( 400000, &_GPIO_MODULE_I2C1_PB67 );
MOVW	R1, #lo_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVT	R1, #hi_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVW	R0, #6784
MOVT	R0, #6
BL	_I2C1_Init_Advanced+0
;mmb_3_fpi_stm32.h,191 :: 		FT5XX6_SetI2CAddress( 0x38 );
MOVS	R0, #56
BL	_FT5XX6_SetI2CAddress+0
;mmb_3_fpi_stm32.h,193 :: 		if ( FT5XX6_IsOperational( ) != FT5XX6_OK )
BL	_FT5XX6_IsOperational+0
CMP	R0, #0
IT	EQ
BEQ	L_mp3_module_hal_touch_init9
;mmb_3_fpi_stm32.h,195 :: 		return FT5XX6_FAILURE;
MOVS	R0, #1
IT	AL
BAL	L_end_hal_touch_init
;mmb_3_fpi_stm32.h,196 :: 		}
L_mp3_module_hal_touch_init9:
;mmb_3_fpi_stm32.h,198 :: 		FT5XX6_SetDefaultMode( );
BL	_FT5XX6_SetDefaultMode+0
;mmb_3_fpi_stm32.h,199 :: 		FT5XX6_SetController( _TC_FT5X26 );
MOVS	R0, #3
BL	_FT5XX6_SetController+0
;mmb_3_fpi_stm32.h,200 :: 		FT5XX6_SetSizeAndRotation( 320, 240, 2 );
MOVS	R2, #2
MOVS	R1, #240
MOVW	R0, #320
BL	_FT5XX6_SetSizeAndRotation+0
;mmb_3_fpi_stm32.h,202 :: 		return FT5XX6_OK;
MOVS	R0, #0
;mmb_3_fpi_stm32.h,203 :: 		}
L_end_hal_touch_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of mp3_module_hal_touch_init
mp3_module_hal_console_init:
;mmb_3_fpi_stm32.h,215 :: 		static void hal_console_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,224 :: 		&_GPIO_MODULE_USART2_PD5_PA3
MOVW	R0, #lo_addr(__GPIO_MODULE_USART2_PD5_PA3+0)
MOVT	R0, #hi_addr(__GPIO_MODULE_USART2_PD5_PA3+0)
PUSH	(R0)
;mmb_3_fpi_stm32.h,223 :: 		_UART_ONE_STOPBIT,
MOVW	R3, #0
;mmb_3_fpi_stm32.h,222 :: 		_UART_NOPARITY,
MOVW	R2, #0
;mmb_3_fpi_stm32.h,221 :: 		_UART_8_BIT_DATA,
MOVW	R1, #0
;mmb_3_fpi_stm32.h,220 :: 		115200,
MOV	R0, #115200
;mmb_3_fpi_stm32.h,224 :: 		&_GPIO_MODULE_USART2_PD5_PA3
BL	_UART2_Init_Advanced+0
ADD	SP, SP, #4
;mmb_3_fpi_stm32.h,226 :: 		}
L_end_hal_console_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of mp3_module_hal_console_init
mp3_module_hal_power_init:
;mmb_3_fpi_stm32.h,259 :: 		static void hal_power_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,267 :: 		GPIO_Digital_Input( &GPIOH_BASE, _GPIO_PINMASK_0 );
MOVW	R1, #1
MOVW	R0, #lo_addr(GPIOH_BASE+0)
MOVT	R0, #hi_addr(GPIOH_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_3_fpi_stm32.h,270 :: 		GPIO_Analog_Input( &GPIOA_BASE, _GPIO_PINMASK_0 );
MOVW	R1, #1
MOVW	R0, #lo_addr(GPIOA_BASE+0)
MOVT	R0, #hi_addr(GPIOA_BASE+0)
BL	_GPIO_Analog_Input+0
;mmb_3_fpi_stm32.h,271 :: 		ADC_Set_Input_Channel( _ADC_CHANNEL_0 );
MOVW	R0, #1
BL	_ADC_Set_Input_Channel+0
;mmb_3_fpi_stm32.h,272 :: 		ADC2_Init( );
BL	_ADC2_Init+0
;mmb_3_fpi_stm32.h,273 :: 		}
L_end_hal_power_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of mp3_module_hal_power_init
mp3_module_hal_microsd_init:
;mmb_3_fpi_stm32.h,291 :: 		static void hal_microsd_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,314 :: 		GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_3 );   // SD_CD
MOVW	R1, #8
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_3_fpi_stm32.h,315 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_2 );  // SD_CMD
MOVW	R1, #4
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_3_fpi_stm32.h,317 :: 		SDIO_Reset( );
BL	_SDIO_Reset+0
;mmb_3_fpi_stm32.h,320 :: 		| _SDIO_CFG_CLOCK_RISING_EDGE  | _SDIO_CFG_HW_FLOW_DISABLE, 125, &_GPIO_MODULE_SDIO_D0_D3 );
MOVW	R2, #lo_addr(__GPIO_MODULE_SDIO_D0_D3+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SDIO_D0_D3+0)
MOVS	R1, #125
MOV	R0, #2048
BL	_SDIO_Init+0
;mmb_3_fpi_stm32.h,323 :: 		GPIOD_PUPDRbits.PUPDR2  = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOD_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOD_PUPDRbits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #4, #2
STRB	R0, [R1, #0]
;mmb_3_fpi_stm32.h,324 :: 		GPIOD_PUPDRbits.PUPDR3  = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOD_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOD_PUPDRbits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #6, #2
STRB	R0, [R1, #0]
;mmb_3_fpi_stm32.h,325 :: 		GPIOC_PUPDRbits.PUPDR8  = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #16, #2
STR	R0, [R1, #0]
;mmb_3_fpi_stm32.h,326 :: 		GPIOC_PUPDRbits.PUPDR9  = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #18, #2
STR	R0, [R1, #0]
;mmb_3_fpi_stm32.h,327 :: 		GPIOC_PUPDRbits.PUPDR10 = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #20, #2
STR	R0, [R1, #0]
;mmb_3_fpi_stm32.h,328 :: 		GPIOC_PUPDRbits.PUPDR11 = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #22, #2
STR	R0, [R1, #0]
;mmb_3_fpi_stm32.h,330 :: 		Mmc_Set_Interface( _MMC_INTERFACE_SDIO );
MOVS	R0, #1
BL	_Mmc_Set_Interface+0
;mmb_3_fpi_stm32.h,333 :: 		}
L_end_hal_microsd_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of mp3_module_hal_microsd_init
mp3_module_hal_flash_init:
;mmb_3_fpi_stm32.h,351 :: 		static void hal_flash_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,355 :: 		GPIO_Digital_Output( &GPIOE_BASE, _GPIO_PINMASK_8 );
MOVW	R1, #256
MOVW	R0, #lo_addr(GPIOE_BASE+0)
MOVT	R0, #hi_addr(GPIOE_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_3_fpi_stm32.h,369 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
MOVW	R2, #lo_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
;mmb_3_fpi_stm32.h,368 :: 		_SPI_SSI_1,
MOVW	R1, #772
;mmb_3_fpi_stm32.h,360 :: 		_SPI_FPCLK_DIV64,
MOVS	R0, #5
;mmb_3_fpi_stm32.h,369 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
BL	_SPI2_Init_Advanced+0
;mmb_3_fpi_stm32.h,372 :: 		BSP_FLASH_CE = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOE_ODR+0)
MOVT	R0, #hi_addr(GPIOE_ODR+0)
_SX	[R0, ByteOffset(GPIOE_ODR+0)]
;mmb_3_fpi_stm32.h,373 :: 		}
L_end_hal_flash_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of mp3_module_hal_flash_init
mp3_module_hal_mp3_init:
;mmb_3_fpi_stm32.h,500 :: 		static void hal_mp3_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,504 :: 		GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_9 );
MOVW	R1, #512
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_3_fpi_stm32.h,508 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_11 );
MOVW	R1, #2048
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_3_fpi_stm32.h,512 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_8 );
MOVW	R1, #256
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_3_fpi_stm32.h,516 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_10 );
MOVW	R1, #1024
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_3_fpi_stm32.h,520 :: 		BSP_MP3_CS            = 1;               // Deselect MP3_CS
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;mmb_3_fpi_stm32.h,521 :: 		BSP_MP3_RST           = 1;               // Set MP3_RST pin
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;mmb_3_fpi_stm32.h,522 :: 		BSP_MP3_DCS           = 1;               // Clear BSYNC
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;mmb_3_fpi_stm32.h,534 :: 		&_GPIO_MODULE_SPI1_PA567);
MOVW	R2, #lo_addr(__GPIO_MODULE_SPI1_PA567+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SPI1_PA567+0)
;mmb_3_fpi_stm32.h,533 :: 		| _SPI_SSI_1,
MOVW	R1, #772
;mmb_3_fpi_stm32.h,525 :: 		SPI1_Init_Advanced( _SPI_FPCLK_DIV64,
MOVS	R0, #5
;mmb_3_fpi_stm32.h,534 :: 		&_GPIO_MODULE_SPI1_PA567);
BL	_SPI1_Init_Advanced+0
;mmb_3_fpi_stm32.h,535 :: 		}
L_end_hal_mp3_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of mp3_module_hal_mp3_init
mp3_module_hal_accel_init:
;mmb_3_fpi_stm32.h,555 :: 		static void hal_accel_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,559 :: 		GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_9 );
MOVW	R1, #512
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_3_fpi_stm32.h,563 :: 		GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_8 );
MOVW	R1, #256
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_3_fpi_stm32.h,567 :: 		I2C1_Init_Advanced( 100000, &_GPIO_MODULE_I2C1_PB67 );
MOVW	R1, #lo_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVT	R1, #hi_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVW	R0, #34464
MOVT	R0, #1
BL	_I2C1_Init_Advanced+0
;mmb_3_fpi_stm32.h,568 :: 		}
L_end_hal_accel_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of mp3_module_hal_accel_init
mp3_module_hal_rtc_init:
;mmb_3_fpi_stm32.h,722 :: 		static void hal_rtc_init ( void )
;mmb_3_fpi_stm32.h,728 :: 		RCC_APB1ENR.B28 = 1;  // Enable the PWR clock
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(RCC_APB1ENR+0)
MOVT	R0, #hi_addr(RCC_APB1ENR+0)
_SX	[R0, ByteOffset(RCC_APB1ENR+0)]
;mmb_3_fpi_stm32.h,729 :: 		if (RCC_BDCR.RTCEN == 0){         // if RTC is disabled ...
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
_LX	[R0, ByteOffset(RCC_BDCR+0)]
CMP	R0, #0
IT	NE
BNE	L_mp3_module_hal_rtc_init10
;mmb_3_fpi_stm32.h,730 :: 		PWR_CR.DBP = 1;                 // Allow access to RTC
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(PWR_CR+0)
MOVT	R0, #hi_addr(PWR_CR+0)
_SX	[R0, ByteOffset(PWR_CR+0)]
;mmb_3_fpi_stm32.h,732 :: 		RTC_WPR = 0xCA;                 //unlock write protection
MOVS	R1, #202
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;mmb_3_fpi_stm32.h,733 :: 		RTC_WPR = 0x53;                 //unlock write protection
MOVS	R1, #83
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;mmb_3_fpi_stm32.h,734 :: 		RCC_CSR = 0x00000000ul;
MOV	R1, #0
MOVW	R0, #lo_addr(RCC_CSR+0)
MOVT	R0, #hi_addr(RCC_CSR+0)
STR	R1, [R0, #0]
;mmb_3_fpi_stm32.h,735 :: 		RCC_BDCR = 0x8101u;          // RTCEN = 1, LSE, LSEON
MOVW	R1, #33025
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
STR	R1, [R0, #0]
;mmb_3_fpi_stm32.h,736 :: 		RTC_CR |= 0x00880000ul;
MOVW	R0, #lo_addr(RTC_CR+0)
MOVT	R0, #hi_addr(RTC_CR+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #8912896
MOVW	R0, #lo_addr(RTC_CR+0)
MOVT	R0, #hi_addr(RTC_CR+0)
STR	R1, [R0, #0]
;mmb_3_fpi_stm32.h,737 :: 		}
L_mp3_module_hal_rtc_init10:
;mmb_3_fpi_stm32.h,738 :: 		while(RTC_ISR.B5 != 1){}         // Wait for RTC APB registers synchronisation
L_mp3_module_hal_rtc_init11:
MOVW	R0, #lo_addr(RTC_ISR+0)
MOVT	R0, #hi_addr(RTC_ISR+0)
_LX	[R0, ByteOffset(RTC_ISR+0)]
CMP	R0, #0
IT	NE
BNE	L_mp3_module_hal_rtc_init12
IT	AL
BAL	L_mp3_module_hal_rtc_init11
L_mp3_module_hal_rtc_init12:
;mmb_3_fpi_stm32.h,740 :: 		while(RCC_BDCR.LSERDY != 1){};    // Wait till LSE is ready
L_mp3_module_hal_rtc_init13:
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
_LX	[R0, ByteOffset(RCC_BDCR+0)]
CMP	R0, #0
IT	NE
BNE	L_mp3_module_hal_rtc_init14
IT	AL
BAL	L_mp3_module_hal_rtc_init13
L_mp3_module_hal_rtc_init14:
;mmb_3_fpi_stm32.h,743 :: 		RTC_WPR = 0xFF;
MOVS	R1, #255
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;mmb_3_fpi_stm32.h,745 :: 		}
L_end_hal_rtc_init:
BX	LR
; end of mp3_module_hal_rtc_init
mp3_module_hal_usb_init:
;mmb_3_fpi_stm32.h,759 :: 		static void hal_usb_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,763 :: 		GPIO_Alternate_Function_Enable( &_GPIO_MODULE_OTG_FS_PA89_10_11_12 );
MOVW	R0, #lo_addr(__GPIO_MODULE_OTG_FS_PA89_10_11_12+0)
MOVT	R0, #hi_addr(__GPIO_MODULE_OTG_FS_PA89_10_11_12+0)
BL	_GPIO_Alternate_Function_Enable+0
;mmb_3_fpi_stm32.h,767 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_6 );
MOVW	R1, #64
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_3_fpi_stm32.h,771 :: 		BSP_USB_PSW = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;mmb_3_fpi_stm32.h,772 :: 		Delay_ms( 100 );
MOVW	R7, #2302
MOVT	R7, #61
NOP
NOP
L_mp3_module_hal_usb_init15:
SUBS	R7, R7, #1
BNE	L_mp3_module_hal_usb_init15
NOP
NOP
NOP
;mmb_3_fpi_stm32.h,773 :: 		BSP_USB_PSW = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;mmb_3_fpi_stm32.h,774 :: 		}
L_end_hal_usb_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of mp3_module_hal_usb_init
_mp3_increase_volume:
;mp3_module.c,56 :: 		void mp3_increase_volume( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mp3_module.c,60 :: 		if (mp3_volume > 0x00)
MOVW	R0, #lo_addr(mp3_module_mp3_volume+0)
MOVT	R0, #hi_addr(mp3_module_mp3_volume+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	LS
BLS	L_mp3_increase_volume17
;mp3_module.c,62 :: 		mp3_volume--;
MOVW	R2, #lo_addr(mp3_module_mp3_volume+0)
MOVT	R2, #hi_addr(mp3_module_mp3_volume+0)
LDRB	R0, [R2, #0]
SUBS	R1, R0, #1
UXTB	R1, R1
STRB	R1, [R2, #0]
;mp3_module.c,65 :: 		aux_volume |= mp3_volume;
UXTB	R0, R1
;mp3_module.c,66 :: 		aux_volume <<= 8;
LSLS	R0, R0, #8
UXTH	R0, R0
;mp3_module.c,67 :: 		aux_volume |= mp3_volume;
ORRS	R0, R1
;mp3_module.c,69 :: 		bsp_mp3_cmd_write( _BSP_MP3_VOL_ADDR, aux_volume );
UXTH	R1, R0
MOVS	R0, #11
BL	_bsp_mp3_cmd_write+0
;mp3_module.c,70 :: 		}
L_mp3_increase_volume17:
;mp3_module.c,71 :: 		}
L_end_mp3_increase_volume:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _mp3_increase_volume
_mp3_decrease_volume:
;mp3_module.c,76 :: 		void mp3_decrease_volume( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mp3_module.c,80 :: 		if (mp3_volume < 0xFD)
MOVW	R0, #lo_addr(mp3_module_mp3_volume+0)
MOVT	R0, #hi_addr(mp3_module_mp3_volume+0)
LDRB	R0, [R0, #0]
CMP	R0, #253
IT	CS
BCS	L_mp3_decrease_volume18
;mp3_module.c,82 :: 		mp3_volume++;
MOVW	R2, #lo_addr(mp3_module_mp3_volume+0)
MOVT	R2, #hi_addr(mp3_module_mp3_volume+0)
LDRB	R0, [R2, #0]
ADDS	R1, R0, #1
UXTB	R1, R1
STRB	R1, [R2, #0]
;mp3_module.c,85 :: 		aux_volume |= mp3_volume;
UXTB	R0, R1
;mp3_module.c,86 :: 		aux_volume <<= 8;
LSLS	R0, R0, #8
UXTH	R0, R0
;mp3_module.c,87 :: 		aux_volume |= mp3_volume;
ORRS	R0, R1
;mp3_module.c,89 :: 		bsp_mp3_cmd_write( _BSP_MP3_VOL_ADDR, aux_volume );
UXTH	R1, R0
MOVS	R0, #11
BL	_bsp_mp3_cmd_write+0
;mp3_module.c,90 :: 		}
L_mp3_decrease_volume18:
;mp3_module.c,91 :: 		}
L_end_mp3_decrease_volume:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _mp3_decrease_volume
_mp3_mute_volume:
;mp3_module.c,99 :: 		void mp3_mute_volume( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mp3_module.c,104 :: 		switch (aux_flag)
IT	AL
BAL	L_mp3_mute_volume19
;mp3_module.c,106 :: 		case 0 :
L_mp3_mute_volume21:
;mp3_module.c,108 :: 		bsp_mp3_cmd_write( _BSP_MP3_VOL_ADDR, 0xFDFD );
MOVW	R1, #65021
MOVS	R0, #11
BL	_bsp_mp3_cmd_write+0
;mp3_module.c,110 :: 		aux_flag = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(mp3_mute_volume_aux_flag_L0+0)
MOVT	R0, #hi_addr(mp3_mute_volume_aux_flag_L0+0)
STRB	R1, [R0, #0]
;mp3_module.c,112 :: 		break;
IT	AL
BAL	L_mp3_mute_volume20
;mp3_module.c,114 :: 		case 1 :
L_mp3_mute_volume22:
;mp3_module.c,117 :: 		aux_volume |= mp3_volume;
MOVW	R2, #lo_addr(mp3_module_mp3_volume+0)
MOVT	R2, #hi_addr(mp3_module_mp3_volume+0)
LDRB	R0, [R2, #0]
;mp3_module.c,118 :: 		aux_volume <<= 8;
LSLS	R1, R0, #8
UXTH	R1, R1
;mp3_module.c,119 :: 		aux_volume |= mp3_volume;
MOV	R0, R2
LDRB	R0, [R0, #0]
ORR	R0, R1, R0, LSL #0
;mp3_module.c,121 :: 		bsp_mp3_cmd_write( _BSP_MP3_VOL_ADDR, aux_volume );
UXTH	R1, R0
MOVS	R0, #11
BL	_bsp_mp3_cmd_write+0
;mp3_module.c,123 :: 		aux_flag = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_mute_volume_aux_flag_L0+0)
MOVT	R0, #hi_addr(mp3_mute_volume_aux_flag_L0+0)
STRB	R1, [R0, #0]
;mp3_module.c,125 :: 		break;
IT	AL
BAL	L_mp3_mute_volume20
;mp3_module.c,127 :: 		default :
L_mp3_mute_volume23:
;mp3_module.c,129 :: 		break;
IT	AL
BAL	L_mp3_mute_volume20
;mp3_module.c,131 :: 		}
L_mp3_mute_volume19:
MOVW	R0, #lo_addr(mp3_mute_volume_aux_flag_L0+0)
MOVT	R0, #hi_addr(mp3_mute_volume_aux_flag_L0+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_mp3_mute_volume21
MOVW	R0, #lo_addr(mp3_mute_volume_aux_flag_L0+0)
MOVT	R0, #hi_addr(mp3_mute_volume_aux_flag_L0+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_mp3_mute_volume22
IT	AL
BAL	L_mp3_mute_volume23
L_mp3_mute_volume20:
;mp3_module.c,132 :: 		}
L_end_mp3_mute_volume:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _mp3_mute_volume
_mp3_next_song:
;mp3_module.c,139 :: 		void mp3_next_song( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mp3_module.c,144 :: 		player_stopped( );
BL	mp3_module_player_stopped+0
;mp3_module.c,146 :: 		switch (mp3_song_number)
IT	AL
BAL	L_mp3_next_song24
;mp3_module.c,148 :: 		case SONG_1:
L_mp3_next_song26:
;mp3_module.c,150 :: 		mp3_song_number = SONG_2;
MOVS	R1, #1
MOVW	R0, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R0, #hi_addr(mp3_module_mp3_song_number+0)
STRB	R1, [R0, #0]
;mp3_module.c,151 :: 		break;
IT	AL
BAL	L_mp3_next_song25
;mp3_module.c,153 :: 		case SONG_2:
L_mp3_next_song27:
;mp3_module.c,155 :: 		mp3_song_number = SONG_3;
MOVS	R1, #2
MOVW	R0, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R0, #hi_addr(mp3_module_mp3_song_number+0)
STRB	R1, [R0, #0]
;mp3_module.c,156 :: 		break;
IT	AL
BAL	L_mp3_next_song25
;mp3_module.c,158 :: 		case SONG_3:
L_mp3_next_song28:
;mp3_module.c,160 :: 		mp3_song_number = SONG_1;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R0, #hi_addr(mp3_module_mp3_song_number+0)
STRB	R1, [R0, #0]
;mp3_module.c,161 :: 		break;
IT	AL
BAL	L_mp3_next_song25
;mp3_module.c,163 :: 		default :
L_mp3_next_song29:
;mp3_module.c,168 :: 		break;
IT	AL
BAL	L_mp3_next_song25
;mp3_module.c,170 :: 		}
L_mp3_next_song24:
MOVW	R0, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R0, #hi_addr(mp3_module_mp3_song_number+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_mp3_next_song26
MOVW	R0, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R0, #hi_addr(mp3_module_mp3_song_number+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_mp3_next_song27
MOVW	R0, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R0, #hi_addr(mp3_module_mp3_song_number+0)
LDRB	R0, [R0, #0]
CMP	R0, #2
IT	EQ
BEQ	L_mp3_next_song28
IT	AL
BAL	L_mp3_next_song29
L_mp3_next_song25:
;mp3_module.c,176 :: 		sd_file.sd_file_size = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_sd_file+256)
MOVT	R0, #hi_addr(mp3_module_sd_file+256)
STR	R1, [R0, #0]
;mp3_module.c,177 :: 		sd_seek = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_sd_seek+0)
MOVT	R0, #hi_addr(mp3_module_sd_seek+0)
STR	R1, [R0, #0]
;mp3_module.c,178 :: 		}
L_end_mp3_next_song:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _mp3_next_song
_mp3_prev_song:
;mp3_module.c,185 :: 		void mp3_prev_song( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mp3_module.c,190 :: 		player_stopped( );
BL	mp3_module_player_stopped+0
;mp3_module.c,192 :: 		switch (mp3_song_number)
IT	AL
BAL	L_mp3_prev_song30
;mp3_module.c,194 :: 		case SONG_1:
L_mp3_prev_song32:
;mp3_module.c,196 :: 		mp3_song_number = SONG_3;
MOVS	R1, #2
MOVW	R0, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R0, #hi_addr(mp3_module_mp3_song_number+0)
STRB	R1, [R0, #0]
;mp3_module.c,197 :: 		break;
IT	AL
BAL	L_mp3_prev_song31
;mp3_module.c,199 :: 		case SONG_2:
L_mp3_prev_song33:
;mp3_module.c,201 :: 		mp3_song_number = SONG_1;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R0, #hi_addr(mp3_module_mp3_song_number+0)
STRB	R1, [R0, #0]
;mp3_module.c,202 :: 		break;
IT	AL
BAL	L_mp3_prev_song31
;mp3_module.c,204 :: 		case SONG_3:
L_mp3_prev_song34:
;mp3_module.c,206 :: 		mp3_song_number = SONG_2;
MOVS	R1, #1
MOVW	R0, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R0, #hi_addr(mp3_module_mp3_song_number+0)
STRB	R1, [R0, #0]
;mp3_module.c,207 :: 		break;
IT	AL
BAL	L_mp3_prev_song31
;mp3_module.c,209 :: 		default :
L_mp3_prev_song35:
;mp3_module.c,214 :: 		break;
IT	AL
BAL	L_mp3_prev_song31
;mp3_module.c,216 :: 		}
L_mp3_prev_song30:
MOVW	R0, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R0, #hi_addr(mp3_module_mp3_song_number+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_mp3_prev_song32
MOVW	R0, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R0, #hi_addr(mp3_module_mp3_song_number+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_mp3_prev_song33
MOVW	R0, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R0, #hi_addr(mp3_module_mp3_song_number+0)
LDRB	R0, [R0, #0]
CMP	R0, #2
IT	EQ
BEQ	L_mp3_prev_song34
IT	AL
BAL	L_mp3_prev_song35
L_mp3_prev_song31:
;mp3_module.c,222 :: 		sd_file.sd_file_size = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_sd_file+256)
MOVT	R0, #hi_addr(mp3_module_sd_file+256)
STR	R1, [R0, #0]
;mp3_module.c,223 :: 		sd_seek = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_sd_seek+0)
MOVT	R0, #hi_addr(mp3_module_sd_seek+0)
STR	R1, [R0, #0]
;mp3_module.c,224 :: 		}
L_end_mp3_prev_song:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _mp3_prev_song
_mp3_module_state_changed:
;mp3_module.c,229 :: 		void mp3_module_state_changed ( void )
;mp3_module.c,231 :: 		switch (mp3_state)
IT	AL
BAL	L_mp3_module_state_changed36
;mp3_module.c,233 :: 		case MP3_PLAY:
L_mp3_module_state_changed38:
;mp3_module.c,235 :: 		mp3_state = MP3_STOP;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_mp3_state+0)
MOVT	R0, #hi_addr(mp3_module_mp3_state+0)
STRB	R1, [R0, #0]
;mp3_module.c,236 :: 		break;
IT	AL
BAL	L_mp3_module_state_changed37
;mp3_module.c,238 :: 		case MP3_STOP:
L_mp3_module_state_changed39:
;mp3_module.c,240 :: 		mp3_state = MP3_PLAY;
MOVS	R1, #1
MOVW	R0, #lo_addr(mp3_module_mp3_state+0)
MOVT	R0, #hi_addr(mp3_module_mp3_state+0)
STRB	R1, [R0, #0]
;mp3_module.c,241 :: 		break;
IT	AL
BAL	L_mp3_module_state_changed37
;mp3_module.c,243 :: 		default :
L_mp3_module_state_changed40:
;mp3_module.c,248 :: 		while(1);
L_mp3_module_state_changed41:
IT	AL
BAL	L_mp3_module_state_changed41
;mp3_module.c,250 :: 		}
L_mp3_module_state_changed36:
MOVW	R0, #lo_addr(mp3_module_mp3_state+0)
MOVT	R0, #hi_addr(mp3_module_mp3_state+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_mp3_module_state_changed38
MOVW	R0, #lo_addr(mp3_module_mp3_state+0)
MOVT	R0, #hi_addr(mp3_module_mp3_state+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_mp3_module_state_changed39
IT	AL
BAL	L_mp3_module_state_changed40
L_mp3_module_state_changed37:
;mp3_module.c,251 :: 		}
L_end_mp3_module_state_changed:
BX	LR
; end of _mp3_module_state_changed
_mp3_module_init:
;mp3_module.c,257 :: 		void mp3_module_init ( module_t ** module )
SUB	SP, SP, #8
STR	LR, [SP, #0]
STR	R0, [SP, #4]
;mp3_module.c,259 :: 		mp3_module.state = MODULE_INACTIVE;
MOVS	R2, #0
MOVW	R1, #lo_addr(mp3_module_mp3_module+0)
MOVT	R1, #hi_addr(mp3_module_mp3_module+0)
STRB	R2, [R1, #0]
;mp3_module.c,266 :: 		bsp_mp3_init( );
BL	_bsp_mp3_init+0
;mp3_module.c,271 :: 		bsp_mp3_cmd_write( _BSP_MP3_MODE_ADDR,   0x0800 );
MOVW	R1, #2048
MOVS	R0, #0
BL	_bsp_mp3_cmd_write+0
;mp3_module.c,272 :: 		bsp_mp3_cmd_write( _BSP_MP3_BASS_ADDR,   0x7A00 );
MOVW	R1, #31232
MOVS	R0, #2
BL	_bsp_mp3_cmd_write+0
;mp3_module.c,273 :: 		bsp_mp3_cmd_write( _BSP_MP3_CLOCKF_ADDR, 0xC000 );
MOVW	R1, #49152
MOVS	R0, #3
BL	_bsp_mp3_cmd_write+0
;mp3_module.c,274 :: 		Delay_ms(100);
MOVW	R7, #2302
MOVT	R7, #61
NOP
NOP
L_mp3_module_init43:
SUBS	R7, R7, #1
BNE	L_mp3_module_init43
NOP
NOP
NOP
;mp3_module.c,275 :: 		bsp_mp3_cmd_write( _BSP_MP3_VOL_ADDR,    0x0000 );
MOVS	R1, #0
MOVS	R0, #11
BL	_bsp_mp3_cmd_write+0
;mp3_module.c,280 :: 		mp3_volume      = 0x00;
MOVS	R2, #0
MOVW	R1, #lo_addr(mp3_module_mp3_volume+0)
MOVT	R1, #hi_addr(mp3_module_mp3_volume+0)
STRB	R2, [R1, #0]
;mp3_module.c,281 :: 		mp3_song_number = SONG_1;
MOVS	R2, #0
MOVW	R1, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R1, #hi_addr(mp3_module_mp3_song_number+0)
STRB	R2, [R1, #0]
;mp3_module.c,286 :: 		strncpy( mp3_playlist[ SONG_1 ].SONG, "song_1.mp3", 11 );
MOVW	R1, #lo_addr(?lstr1_mp3_module+0)
MOVT	R1, #hi_addr(?lstr1_mp3_module+0)
MOVS	R2, #11
SXTH	R2, R2
MOVW	R0, #lo_addr(mp3_module_mp3_playlist+0)
MOVT	R0, #hi_addr(mp3_module_mp3_playlist+0)
BL	_strncpy+0
;mp3_module.c,287 :: 		strncpy( mp3_playlist[ SONG_2 ].SONG, "song_2.mp3", 11 );
MOVW	R1, #lo_addr(?lstr2_mp3_module+0)
MOVT	R1, #hi_addr(?lstr2_mp3_module+0)
MOVS	R2, #11
SXTH	R2, R2
MOVW	R0, #lo_addr(mp3_module_mp3_playlist+22)
MOVT	R0, #hi_addr(mp3_module_mp3_playlist+22)
BL	_strncpy+0
;mp3_module.c,288 :: 		strncpy( mp3_playlist[ SONG_3 ].SONG, "song_3.mp3", 11 );
MOVW	R1, #lo_addr(?lstr3_mp3_module+0)
MOVT	R1, #hi_addr(?lstr3_mp3_module+0)
MOVS	R2, #11
SXTH	R2, R2
MOVW	R0, #lo_addr(mp3_module_mp3_playlist+44)
MOVT	R0, #hi_addr(mp3_module_mp3_playlist+44)
BL	_strncpy+0
;mp3_module.c,298 :: 		sd_file.sd_file_size = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(mp3_module_sd_file+256)
MOVT	R1, #hi_addr(mp3_module_sd_file+256)
STR	R2, [R1, #0]
;mp3_module.c,299 :: 		sd_file.sd_file_state = SD_FILE_CLOSED;
MOVS	R2, #0
MOVW	R1, #lo_addr(mp3_module_sd_file+260)
MOVT	R1, #hi_addr(mp3_module_sd_file+260)
STRB	R2, [R1, #0]
;mp3_module.c,306 :: 		*module = &mp3_module;
MOVW	R2, #lo_addr(mp3_module_mp3_module+0)
MOVT	R2, #hi_addr(mp3_module_mp3_module+0)
LDR	R1, [SP, #4]
STR	R2, [R1, #0]
;mp3_module.c,307 :: 		}
L_end_mp3_module_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _mp3_module_init
_mp3_module_task:
;mp3_module.c,309 :: 		void mp3_module_task ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mp3_module.c,311 :: 		switch ( mp3_module.state )
IT	AL
BAL	L_mp3_module_task45
;mp3_module.c,313 :: 		case MODULE_INACTIVE :
L_mp3_module_task47:
;mp3_module.c,318 :: 		DrawImage( &Image_00_03_MP3 );
MOVW	R0, #lo_addr(_Image_00_03_MP3+0)
MOVT	R0, #hi_addr(_Image_00_03_MP3+0)
BL	_DrawImage+0
;mp3_module.c,319 :: 		DrawButton( &Button_00_04_PLAY );
MOVW	R0, #lo_addr(_Button_00_04_PLAY+0)
MOVT	R0, #hi_addr(_Button_00_04_PLAY+0)
BL	_DrawButton+0
;mp3_module.c,320 :: 		DrawButton( &Button_00_05_MUTE );
MOVW	R0, #lo_addr(_Button_00_05_MUTE+0)
MOVT	R0, #hi_addr(_Button_00_05_MUTE+0)
BL	_DrawButton+0
;mp3_module.c,321 :: 		DrawButton( &Button_00_06_VOL_INC );
MOVW	R0, #lo_addr(_Button_00_06_VOL_INC+0)
MOVT	R0, #hi_addr(_Button_00_06_VOL_INC+0)
BL	_DrawButton+0
;mp3_module.c,322 :: 		DrawButton( &Button_00_07_VOL_DEC );
MOVW	R0, #lo_addr(_Button_00_07_VOL_DEC+0)
MOVT	R0, #hi_addr(_Button_00_07_VOL_DEC+0)
BL	_DrawButton+0
;mp3_module.c,323 :: 		DrawButton( &Button_00_08_NEXT );
MOVW	R0, #lo_addr(_Button_00_08_NEXT+0)
MOVT	R0, #hi_addr(_Button_00_08_NEXT+0)
BL	_DrawButton+0
;mp3_module.c,324 :: 		DrawButton( &Button_00_09_PREV );
MOVW	R0, #lo_addr(_Button_00_09_PREV+0)
MOVT	R0, #hi_addr(_Button_00_09_PREV+0)
BL	_DrawButton+0
;mp3_module.c,330 :: 		mp3_module.state = MODULE_ACTIVE;
MOVS	R1, #1
MOVW	R0, #lo_addr(mp3_module_mp3_module+0)
MOVT	R0, #hi_addr(mp3_module_mp3_module+0)
STRB	R1, [R0, #0]
;mp3_module.c,331 :: 		mp3_state = MP3_STOP;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_mp3_state+0)
MOVT	R0, #hi_addr(mp3_module_mp3_state+0)
STRB	R1, [R0, #0]
;mp3_module.c,333 :: 		break;
IT	AL
BAL	L_mp3_module_task46
;mp3_module.c,335 :: 		case MODULE_ACTIVE :
L_mp3_module_task48:
;mp3_module.c,337 :: 		switch ( mp3_state )
IT	AL
BAL	L_mp3_module_task49
;mp3_module.c,339 :: 		case MP3_STOP :
L_mp3_module_task51:
;mp3_module.c,341 :: 		player_stopped( );
BL	mp3_module_player_stopped+0
;mp3_module.c,343 :: 		break;
IT	AL
BAL	L_mp3_module_task50
;mp3_module.c,345 :: 		case MP3_PLAY :
L_mp3_module_task52:
;mp3_module.c,347 :: 		player_running( );
BL	mp3_module_player_running+0
;mp3_module.c,349 :: 		break;
IT	AL
BAL	L_mp3_module_task50
;mp3_module.c,351 :: 		default :
L_mp3_module_task53:
;mp3_module.c,356 :: 		while (1);
L_mp3_module_task54:
IT	AL
BAL	L_mp3_module_task54
;mp3_module.c,358 :: 		}
L_mp3_module_task49:
MOVW	R0, #lo_addr(mp3_module_mp3_state+0)
MOVT	R0, #hi_addr(mp3_module_mp3_state+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_mp3_module_task51
MOVW	R0, #lo_addr(mp3_module_mp3_state+0)
MOVT	R0, #hi_addr(mp3_module_mp3_state+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_mp3_module_task52
IT	AL
BAL	L_mp3_module_task53
L_mp3_module_task50:
;mp3_module.c,360 :: 		break;
IT	AL
BAL	L_mp3_module_task46
;mp3_module.c,362 :: 		default :
L_mp3_module_task56:
;mp3_module.c,367 :: 		while (1);
L_mp3_module_task57:
IT	AL
BAL	L_mp3_module_task57
;mp3_module.c,369 :: 		}
L_mp3_module_task45:
MOVW	R0, #lo_addr(mp3_module_mp3_module+0)
MOVT	R0, #hi_addr(mp3_module_mp3_module+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_mp3_module_task47
MOVW	R0, #lo_addr(mp3_module_mp3_module+0)
MOVT	R0, #hi_addr(mp3_module_mp3_module+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_mp3_module_task48
IT	AL
BAL	L_mp3_module_task56
L_mp3_module_task46:
;mp3_module.c,370 :: 		}
L_end_mp3_module_task:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _mp3_module_task
mp3_module_player_running:
;mp3_module.c,374 :: 		static void player_running ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mp3_module.c,378 :: 		switch (sd_file.sd_file_state)
IT	AL
BAL	L_mp3_module_player_running59
;mp3_module.c,380 :: 		case SD_FILE_CLOSED:
L_mp3_module_player_running61:
;mp3_module.c,382 :: 		sd_fd = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(mp3_module_sd_fd+0)
MOVT	R0, #hi_addr(mp3_module_sd_fd+0)
STRB	R1, [R0, #0]
;mp3_module.c,387 :: 		if (( sd_fd = FAT32_Open( mp3_playlist[ mp3_song_number ].SONG, FILE_READ ) ) >= 0)
MOVW	R0, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R0, #hi_addr(mp3_module_mp3_song_number+0)
LDRB	R1, [R0, #0]
MOVS	R0, #22
MULS	R1, R0, R1
MOVW	R0, #lo_addr(mp3_module_mp3_playlist+0)
MOVT	R0, #hi_addr(mp3_module_mp3_playlist+0)
ADDS	R0, R0, R1
MOVS	R1, #1
BL	_FAT32_Open+0
MOVW	R1, #lo_addr(mp3_module_sd_fd+0)
MOVT	R1, #hi_addr(mp3_module_sd_fd+0)
STRB	R0, [R1, #0]
CMP	R0, #0
IT	LT
BLT	L_mp3_module_player_running62
;mp3_module.c,392 :: 		}
IT	AL
BAL	L_mp3_module_player_running63
L_mp3_module_player_running62:
;mp3_module.c,398 :: 		while (1);
L_mp3_module_player_running64:
IT	AL
BAL	L_mp3_module_player_running64
;mp3_module.c,399 :: 		}
L_mp3_module_player_running63:
;mp3_module.c,404 :: 		if (( sd_err = FAT32_Size( mp3_playlist[ mp3_song_number ].SONG, &sd_file.sd_file_size ) ) >= 0)
MOVW	R0, #lo_addr(mp3_module_mp3_song_number+0)
MOVT	R0, #hi_addr(mp3_module_mp3_song_number+0)
LDRB	R1, [R0, #0]
MOVS	R0, #22
MULS	R1, R0, R1
MOVW	R0, #lo_addr(mp3_module_mp3_playlist+0)
MOVT	R0, #hi_addr(mp3_module_mp3_playlist+0)
ADDS	R0, R0, R1
MOVW	R1, #lo_addr(mp3_module_sd_file+256)
MOVT	R1, #hi_addr(mp3_module_sd_file+256)
BL	_FAT32_Size+0
MOVW	R1, #lo_addr(mp3_module_sd_err+0)
MOVT	R1, #hi_addr(mp3_module_sd_err+0)
STRB	R0, [R1, #0]
CMP	R0, #0
IT	LT
BLT	L_mp3_module_player_running66
;mp3_module.c,409 :: 		sd_seek = 0; /** This variable is used with 'FAT32_Seek()' function to seek last played byte from SD file */
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_sd_seek+0)
MOVT	R0, #hi_addr(mp3_module_sd_seek+0)
STR	R1, [R0, #0]
;mp3_module.c,410 :: 		}
IT	AL
BAL	L_mp3_module_player_running67
L_mp3_module_player_running66:
;mp3_module.c,416 :: 		while (1);
L_mp3_module_player_running68:
IT	AL
BAL	L_mp3_module_player_running68
;mp3_module.c,417 :: 		}
L_mp3_module_player_running67:
;mp3_module.c,422 :: 		sd_file.sd_file_state = SD_FILE_OPEN;
MOVS	R1, #1
MOVW	R0, #lo_addr(mp3_module_sd_file+260)
MOVT	R0, #hi_addr(mp3_module_sd_file+260)
STRB	R1, [R0, #0]
;mp3_module.c,424 :: 		break;
IT	AL
BAL	L_mp3_module_player_running60
;mp3_module.c,426 :: 		case SD_FILE_OPEN:
L_mp3_module_player_running70:
;mp3_module.c,428 :: 		if (sd_file.sd_file_size > 32)
MOVW	R0, #lo_addr(mp3_module_sd_file+256)
MOVT	R0, #hi_addr(mp3_module_sd_file+256)
LDR	R0, [R0, #0]
CMP	R0, #32
IT	LS
BLS	L_mp3_module_player_running71
;mp3_module.c,433 :: 		if (( sd_err = FAT32_Read( sd_fd, sd_file.sd_file_data, 32 ) ) >= 0)
MOVW	R0, #lo_addr(mp3_module_sd_fd+0)
MOVT	R0, #hi_addr(mp3_module_sd_fd+0)
LDRSB	R0, [R0, #0]
MOVS	R2, #32
MOVW	R1, #lo_addr(mp3_module_sd_file+0)
MOVT	R1, #hi_addr(mp3_module_sd_file+0)
BL	_FAT32_Read+0
MOVW	R1, #lo_addr(mp3_module_sd_err+0)
MOVT	R1, #hi_addr(mp3_module_sd_err+0)
STRB	R0, [R1, #0]
CMP	R0, #0
IT	LT
BLT	L_mp3_module_player_running72
;mp3_module.c,435 :: 		for (i = 0; i < 32; i ++)
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_player_running_i_L0+0)
MOVT	R0, #hi_addr(mp3_module_player_running_i_L0+0)
STRB	R1, [R0, #0]
L_mp3_module_player_running73:
MOVW	R0, #lo_addr(mp3_module_player_running_i_L0+0)
MOVT	R0, #hi_addr(mp3_module_player_running_i_L0+0)
LDRB	R0, [R0, #0]
CMP	R0, #32
IT	CS
BCS	L_mp3_module_player_running74
;mp3_module.c,440 :: 		while ( bsp_mp3_data_write( sd_file.sd_file_data[ i ] ) );
L_mp3_module_player_running76:
MOVW	R0, #lo_addr(mp3_module_player_running_i_L0+0)
MOVT	R0, #hi_addr(mp3_module_player_running_i_L0+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(mp3_module_sd_file+0)
MOVT	R0, #hi_addr(mp3_module_sd_file+0)
ADDS	R0, R0, R1
LDRB	R0, [R0, #0]
BL	_bsp_mp3_data_write+0
CMP	R0, #0
IT	EQ
BEQ	L_mp3_module_player_running77
IT	AL
BAL	L_mp3_module_player_running76
L_mp3_module_player_running77:
;mp3_module.c,435 :: 		for (i = 0; i < 32; i ++)
MOVW	R1, #lo_addr(mp3_module_player_running_i_L0+0)
MOVT	R1, #hi_addr(mp3_module_player_running_i_L0+0)
LDRB	R0, [R1, #0]
ADDS	R0, R0, #1
STRB	R0, [R1, #0]
;mp3_module.c,441 :: 		}
IT	AL
BAL	L_mp3_module_player_running73
L_mp3_module_player_running74:
;mp3_module.c,447 :: 		sd_file.sd_file_size -= 32;
MOVW	R1, #lo_addr(mp3_module_sd_file+256)
MOVT	R1, #hi_addr(mp3_module_sd_file+256)
LDR	R0, [R1, #0]
SUBS	R0, #32
STR	R0, [R1, #0]
;mp3_module.c,448 :: 		sd_seek += 32;
MOVW	R1, #lo_addr(mp3_module_sd_seek+0)
MOVT	R1, #hi_addr(mp3_module_sd_seek+0)
LDR	R0, [R1, #0]
ADDS	R0, #32
STR	R0, [R1, #0]
;mp3_module.c,453 :: 		FAT32_Seek( sd_fd, sd_seek );
MOV	R1, R0
MOVW	R0, #lo_addr(mp3_module_sd_fd+0)
MOVT	R0, #hi_addr(mp3_module_sd_fd+0)
LDRSB	R0, [R0, #0]
BL	_FAT32_Seek+0
;mp3_module.c,454 :: 		}
IT	AL
BAL	L_mp3_module_player_running78
L_mp3_module_player_running72:
;mp3_module.c,460 :: 		while (1);
L_mp3_module_player_running79:
IT	AL
BAL	L_mp3_module_player_running79
;mp3_module.c,461 :: 		}
L_mp3_module_player_running78:
;mp3_module.c,462 :: 		}
IT	AL
BAL	L_mp3_module_player_running81
L_mp3_module_player_running71:
;mp3_module.c,463 :: 		else if (sd_file.sd_file_size > 0)
MOVW	R0, #lo_addr(mp3_module_sd_file+256)
MOVT	R0, #hi_addr(mp3_module_sd_file+256)
LDR	R0, [R0, #0]
CMP	R0, #0
IT	LS
BLS	L_mp3_module_player_running82
;mp3_module.c,468 :: 		if (( sd_err = FAT32_Read( sd_fd, sd_file.sd_file_data, sd_file.sd_file_size ) ) >= 0)
MOVW	R0, #lo_addr(mp3_module_sd_file+256)
MOVT	R0, #hi_addr(mp3_module_sd_file+256)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(mp3_module_sd_fd+0)
MOVT	R0, #hi_addr(mp3_module_sd_fd+0)
LDRSB	R0, [R0, #0]
UXTH	R2, R1
MOVW	R1, #lo_addr(mp3_module_sd_file+0)
MOVT	R1, #hi_addr(mp3_module_sd_file+0)
BL	_FAT32_Read+0
MOVW	R1, #lo_addr(mp3_module_sd_err+0)
MOVT	R1, #hi_addr(mp3_module_sd_err+0)
STRB	R0, [R1, #0]
CMP	R0, #0
IT	LT
BLT	L_mp3_module_player_running83
;mp3_module.c,473 :: 		for (i = 0; i < sd_file.sd_file_size; i ++)
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_player_running_i_L0+0)
MOVT	R0, #hi_addr(mp3_module_player_running_i_L0+0)
STRB	R1, [R0, #0]
L_mp3_module_player_running84:
MOVW	R0, #lo_addr(mp3_module_sd_file+256)
MOVT	R0, #hi_addr(mp3_module_sd_file+256)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(mp3_module_player_running_i_L0+0)
MOVT	R0, #hi_addr(mp3_module_player_running_i_L0+0)
LDRB	R0, [R0, #0]
CMP	R0, R1
IT	CS
BCS	L_mp3_module_player_running85
;mp3_module.c,475 :: 		while ( bsp_mp3_data_write( sd_file.sd_file_data[ i ] ) );
L_mp3_module_player_running87:
MOVW	R0, #lo_addr(mp3_module_player_running_i_L0+0)
MOVT	R0, #hi_addr(mp3_module_player_running_i_L0+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(mp3_module_sd_file+0)
MOVT	R0, #hi_addr(mp3_module_sd_file+0)
ADDS	R0, R0, R1
LDRB	R0, [R0, #0]
BL	_bsp_mp3_data_write+0
CMP	R0, #0
IT	EQ
BEQ	L_mp3_module_player_running88
IT	AL
BAL	L_mp3_module_player_running87
L_mp3_module_player_running88:
;mp3_module.c,473 :: 		for (i = 0; i < sd_file.sd_file_size; i ++)
MOVW	R1, #lo_addr(mp3_module_player_running_i_L0+0)
MOVT	R1, #hi_addr(mp3_module_player_running_i_L0+0)
LDRB	R0, [R1, #0]
ADDS	R0, R0, #1
STRB	R0, [R1, #0]
;mp3_module.c,476 :: 		}
IT	AL
BAL	L_mp3_module_player_running84
L_mp3_module_player_running85:
;mp3_module.c,482 :: 		sd_file.sd_file_size = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_sd_file+256)
MOVT	R0, #hi_addr(mp3_module_sd_file+256)
STR	R1, [R0, #0]
;mp3_module.c,483 :: 		sd_seek = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_sd_seek+0)
MOVT	R0, #hi_addr(mp3_module_sd_seek+0)
STR	R1, [R0, #0]
;mp3_module.c,484 :: 		}
IT	AL
BAL	L_mp3_module_player_running89
L_mp3_module_player_running83:
;mp3_module.c,490 :: 		while (1);
L_mp3_module_player_running90:
IT	AL
BAL	L_mp3_module_player_running90
;mp3_module.c,491 :: 		}
L_mp3_module_player_running89:
;mp3_module.c,492 :: 		}
IT	AL
BAL	L_mp3_module_player_running92
L_mp3_module_player_running82:
;mp3_module.c,495 :: 		switch (sd_file.sd_file_state)
IT	AL
BAL	L_mp3_module_player_running93
;mp3_module.c,497 :: 		case SD_FILE_CLOSED:
L_mp3_module_player_running95:
;mp3_module.c,502 :: 		while (1);
L_mp3_module_player_running96:
IT	AL
BAL	L_mp3_module_player_running96
;mp3_module.c,504 :: 		case SD_FILE_OPEN:
L_mp3_module_player_running98:
;mp3_module.c,509 :: 		if (( sd_err = FAT32_Close( sd_fd ) ) >= 0)
MOVW	R0, #lo_addr(mp3_module_sd_fd+0)
MOVT	R0, #hi_addr(mp3_module_sd_fd+0)
LDRSB	R0, [R0, #0]
BL	_FAT32_Close+0
MOVW	R1, #lo_addr(mp3_module_sd_err+0)
MOVT	R1, #hi_addr(mp3_module_sd_err+0)
STRB	R0, [R1, #0]
CMP	R0, #0
IT	LT
BLT	L_mp3_module_player_running99
;mp3_module.c,514 :: 		}
IT	AL
BAL	L_mp3_module_player_running100
L_mp3_module_player_running99:
;mp3_module.c,520 :: 		while (1);
L_mp3_module_player_running101:
IT	AL
BAL	L_mp3_module_player_running101
;mp3_module.c,521 :: 		}
L_mp3_module_player_running100:
;mp3_module.c,526 :: 		sd_file.sd_file_state = SD_FILE_CLOSED;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_sd_file+260)
MOVT	R0, #hi_addr(mp3_module_sd_file+260)
STRB	R1, [R0, #0]
;mp3_module.c,528 :: 		break;
IT	AL
BAL	L_mp3_module_player_running94
;mp3_module.c,530 :: 		default :
L_mp3_module_player_running103:
;mp3_module.c,535 :: 		while (1);
L_mp3_module_player_running104:
IT	AL
BAL	L_mp3_module_player_running104
;mp3_module.c,537 :: 		}
L_mp3_module_player_running93:
MOVW	R0, #lo_addr(mp3_module_sd_file+260)
MOVT	R0, #hi_addr(mp3_module_sd_file+260)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_mp3_module_player_running95
MOVW	R0, #lo_addr(mp3_module_sd_file+260)
MOVT	R0, #hi_addr(mp3_module_sd_file+260)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_mp3_module_player_running98
IT	AL
BAL	L_mp3_module_player_running103
L_mp3_module_player_running94:
;mp3_module.c,538 :: 		}
L_mp3_module_player_running92:
L_mp3_module_player_running81:
;mp3_module.c,540 :: 		break;
IT	AL
BAL	L_mp3_module_player_running60
;mp3_module.c,542 :: 		default :
L_mp3_module_player_running106:
;mp3_module.c,547 :: 		while (1);
L_mp3_module_player_running107:
IT	AL
BAL	L_mp3_module_player_running107
;mp3_module.c,549 :: 		}
L_mp3_module_player_running59:
MOVW	R0, #lo_addr(mp3_module_sd_file+260)
MOVT	R0, #hi_addr(mp3_module_sd_file+260)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_mp3_module_player_running61
MOVW	R0, #lo_addr(mp3_module_sd_file+260)
MOVT	R0, #hi_addr(mp3_module_sd_file+260)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_mp3_module_player_running70
IT	AL
BAL	L_mp3_module_player_running106
L_mp3_module_player_running60:
;mp3_module.c,550 :: 		}
L_end_player_running:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of mp3_module_player_running
mp3_module_player_stopped:
;mp3_module.c,552 :: 		static void player_stopped ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mp3_module.c,554 :: 		switch (sd_file.sd_file_state)
IT	AL
BAL	L_mp3_module_player_stopped109
;mp3_module.c,556 :: 		case SD_FILE_CLOSED:
L_mp3_module_player_stopped111:
;mp3_module.c,561 :: 		break;
IT	AL
BAL	L_mp3_module_player_stopped110
;mp3_module.c,563 :: 		case SD_FILE_OPEN:
L_mp3_module_player_stopped112:
;mp3_module.c,568 :: 		if (( sd_err = FAT32_Close( sd_fd ) ) >= 0)
MOVW	R0, #lo_addr(mp3_module_sd_fd+0)
MOVT	R0, #hi_addr(mp3_module_sd_fd+0)
LDRSB	R0, [R0, #0]
BL	_FAT32_Close+0
MOVW	R1, #lo_addr(mp3_module_sd_err+0)
MOVT	R1, #hi_addr(mp3_module_sd_err+0)
STRB	R0, [R1, #0]
CMP	R0, #0
IT	LT
BLT	L_mp3_module_player_stopped113
;mp3_module.c,570 :: 		sd_file.sd_file_state = SD_FILE_CLOSED;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_sd_file+260)
MOVT	R0, #hi_addr(mp3_module_sd_file+260)
STRB	R1, [R0, #0]
;mp3_module.c,572 :: 		sd_file.sd_file_size = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_sd_file+256)
MOVT	R0, #hi_addr(mp3_module_sd_file+256)
STR	R1, [R0, #0]
;mp3_module.c,573 :: 		sd_seek = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(mp3_module_sd_seek+0)
MOVT	R0, #hi_addr(mp3_module_sd_seek+0)
STR	R1, [R0, #0]
;mp3_module.c,574 :: 		}
IT	AL
BAL	L_mp3_module_player_stopped114
L_mp3_module_player_stopped113:
;mp3_module.c,580 :: 		while (1);
L_mp3_module_player_stopped115:
IT	AL
BAL	L_mp3_module_player_stopped115
;mp3_module.c,581 :: 		}
L_mp3_module_player_stopped114:
;mp3_module.c,583 :: 		break;
IT	AL
BAL	L_mp3_module_player_stopped110
;mp3_module.c,585 :: 		default :
L_mp3_module_player_stopped117:
;mp3_module.c,590 :: 		while (1);
L_mp3_module_player_stopped118:
IT	AL
BAL	L_mp3_module_player_stopped118
;mp3_module.c,592 :: 		}
L_mp3_module_player_stopped109:
MOVW	R0, #lo_addr(mp3_module_sd_file+260)
MOVT	R0, #hi_addr(mp3_module_sd_file+260)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_mp3_module_player_stopped111
MOVW	R0, #lo_addr(mp3_module_sd_file+260)
MOVT	R0, #hi_addr(mp3_module_sd_file+260)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_mp3_module_player_stopped112
IT	AL
BAL	L_mp3_module_player_stopped117
L_mp3_module_player_stopped110:
;mp3_module.c,593 :: 		}
L_end_player_stopped:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of mp3_module_player_stopped
