flowcont_Write_to_Data_Lines:
;mmb_3_fpi_stm32.h,86 :: 		static void Write_to_Data_Lines ( unsigned char _hi, unsigned char _lo )
; _lo start address is: 4 (R1)
; _hi start address is: 0 (R0)
; _lo end address is: 4 (R1)
; _hi end address is: 0 (R0)
; _hi start address is: 0 (R0)
; _lo start address is: 4 (R1)
;mmb_3_fpi_stm32.h,88 :: 		unsigned int tmp = GPIOE_ODR;
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
; tmp start address is: 12 (R3)
LDR	R3, [R2, #0]
;mmb_3_fpi_stm32.h,89 :: 		tmp &= 0xFF00;
AND	R2, R3, #65280
UXTH	R2, R2
; tmp end address is: 12 (R3)
;mmb_3_fpi_stm32.h,90 :: 		GPIOE_ODR = tmp | _hi;
ORR	R3, R2, R0, LSL #0
UXTH	R3, R3
; _hi end address is: 0 (R0)
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
STR	R3, [R2, #0]
;mmb_3_fpi_stm32.h,91 :: 		tmp = GPIOE_ODR;
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
; tmp start address is: 0 (R0)
LDR	R0, [R2, #0]
;mmb_3_fpi_stm32.h,92 :: 		tmp &= 0xFF00;
AND	R2, R0, #65280
UXTH	R2, R2
; tmp end address is: 0 (R0)
;mmb_3_fpi_stm32.h,93 :: 		GPIOE_ODR = tmp | _lo;
ORR	R3, R2, R1, LSL #0
UXTH	R3, R3
; _lo end address is: 4 (R1)
MOVW	R2, #lo_addr(GPIOE_ODR+0)
MOVT	R2, #hi_addr(GPIOE_ODR+0)
STR	R3, [R2, #0]
;mmb_3_fpi_stm32.h,94 :: 		}
L_end_Write_to_Data_Lines:
BX	LR
; end of flowcont_Write_to_Data_Lines
flowcont_Write_to_Data_Lines_8bit:
;mmb_3_fpi_stm32.h,96 :: 		static void Write_to_Data_Lines_8bit ( unsigned char _data )
; _data start address is: 0 (R0)
; _data end address is: 0 (R0)
; _data start address is: 0 (R0)
;mmb_3_fpi_stm32.h,98 :: 		unsigned int tmp = GPIOE_ODR;
MOVW	R1, #lo_addr(GPIOE_ODR+0)
MOVT	R1, #hi_addr(GPIOE_ODR+0)
; tmp start address is: 8 (R2)
LDR	R2, [R1, #0]
;mmb_3_fpi_stm32.h,99 :: 		tmp &= 0xFF00;
AND	R1, R2, #65280
UXTH	R1, R1
; tmp end address is: 8 (R2)
;mmb_3_fpi_stm32.h,100 :: 		GPIOE_ODR = tmp | _data;
ORR	R2, R1, R0, LSL #0
UXTH	R2, R2
; _data end address is: 0 (R0)
MOVW	R1, #lo_addr(GPIOE_ODR+0)
MOVT	R1, #hi_addr(GPIOE_ODR+0)
STR	R2, [R1, #0]
;mmb_3_fpi_stm32.h,101 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_3_fpi_stm32.h,102 :: 		asm nop;
NOP
;mmb_3_fpi_stm32.h,103 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_3_fpi_stm32.h,104 :: 		}
L_end_Write_to_Data_Lines_8bit:
BX	LR
; end of flowcont_Write_to_Data_Lines_8bit
flowcont_Set_Index:
;mmb_3_fpi_stm32.h,106 :: 		static void Set_Index ( unsigned short index )
; index start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; index end address is: 0 (R0)
; index start address is: 0 (R0)
;mmb_3_fpi_stm32.h,108 :: 		TFT_RS = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_RS+0)
MOVT	R1, #hi_addr(TFT_RS+0)
_SX	[R1, ByteOffset(TFT_RS+0)]
;mmb_3_fpi_stm32.h,109 :: 		Write_to_Data_Lines(0, index);
UXTB	R1, R0
; index end address is: 0 (R0)
MOVS	R0, #0
BL	flowcont_Write_to_Data_Lines+0
;mmb_3_fpi_stm32.h,110 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_3_fpi_stm32.h,111 :: 		asm nop;
NOP
;mmb_3_fpi_stm32.h,112 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_3_fpi_stm32.h,113 :: 		}
L_end_Set_Index:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of flowcont_Set_Index
flowcont_Write_Command:
;mmb_3_fpi_stm32.h,115 :: 		static void Write_Command ( unsigned short cmd )
; cmd start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; cmd end address is: 0 (R0)
; cmd start address is: 0 (R0)
;mmb_3_fpi_stm32.h,117 :: 		TFT_RS = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_RS+0)
MOVT	R1, #hi_addr(TFT_RS+0)
_SX	[R1, ByteOffset(TFT_RS+0)]
;mmb_3_fpi_stm32.h,118 :: 		Write_to_Data_Lines(0, cmd);
UXTB	R1, R0
; cmd end address is: 0 (R0)
MOVS	R0, #0
BL	flowcont_Write_to_Data_Lines+0
;mmb_3_fpi_stm32.h,119 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_3_fpi_stm32.h,120 :: 		asm nop;
NOP
;mmb_3_fpi_stm32.h,121 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_WR+0)
MOVT	R1, #hi_addr(TFT_WR+0)
_SX	[R1, ByteOffset(TFT_WR+0)]
;mmb_3_fpi_stm32.h,122 :: 		}
L_end_Write_Command:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of flowcont_Write_Command
flowcont_Write_Data:
;mmb_3_fpi_stm32.h,124 :: 		static void Write_Data ( unsigned int _data )
; _data start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
UXTH	R3, R0
; _data end address is: 0 (R0)
; _data start address is: 12 (R3)
;mmb_3_fpi_stm32.h,128 :: 		TFT_RS = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(TFT_RS+0)
MOVT	R1, #hi_addr(TFT_RS+0)
_SX	[R1, ByteOffset(TFT_RS+0)]
;mmb_3_fpi_stm32.h,129 :: 		temp = (_data>>11);
LSRS	R1, R3, #11
; temp start address is: 0 (R0)
UXTB	R0, R1
;mmb_3_fpi_stm32.h,130 :: 		temp = (temp<<3);
LSLS	R1, R0, #3
; temp end address is: 0 (R0)
; temp start address is: 16 (R4)
UXTB	R4, R1
;mmb_3_fpi_stm32.h,132 :: 		if ((temp>>7) == 1)
LSRS	R1, R4, #7
UXTB	R1, R1
CMP	R1, #1
IT	NE
BNE	L_flowcont_Write_Data17
;mmb_3_fpi_stm32.h,134 :: 		temp += 7;
ADDS	R1, R4, #7
; temp end address is: 16 (R4)
; temp start address is: 0 (R0)
UXTB	R0, R1
; temp end address is: 0 (R0)
;mmb_3_fpi_stm32.h,135 :: 		}
IT	AL
BAL	L_flowcont_Write_Data0
L_flowcont_Write_Data17:
;mmb_3_fpi_stm32.h,132 :: 		if ((temp>>7) == 1)
UXTB	R0, R4
;mmb_3_fpi_stm32.h,135 :: 		}
L_flowcont_Write_Data0:
;mmb_3_fpi_stm32.h,137 :: 		Write_to_Data_Lines_8bit(temp);
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
BL	flowcont_Write_to_Data_Lines_8bit+0
;mmb_3_fpi_stm32.h,138 :: 		temp = (_data>>5);
LSRS	R1, R3, #5
; temp start address is: 0 (R0)
UXTB	R0, R1
;mmb_3_fpi_stm32.h,139 :: 		temp = (temp<<2);
LSLS	R1, R0, #2
; temp end address is: 0 (R0)
; temp start address is: 16 (R4)
UXTB	R4, R1
;mmb_3_fpi_stm32.h,141 :: 		if ((temp>>7) == 1)
LSRS	R1, R4, #7
UXTB	R1, R1
CMP	R1, #1
IT	NE
BNE	L_flowcont_Write_Data18
;mmb_3_fpi_stm32.h,143 :: 		temp += 3;
ADDS	R1, R4, #3
; temp end address is: 16 (R4)
; temp start address is: 0 (R0)
UXTB	R0, R1
; temp end address is: 0 (R0)
;mmb_3_fpi_stm32.h,144 :: 		}
IT	AL
BAL	L_flowcont_Write_Data1
L_flowcont_Write_Data18:
;mmb_3_fpi_stm32.h,141 :: 		if ((temp>>7) == 1)
UXTB	R0, R4
;mmb_3_fpi_stm32.h,144 :: 		}
L_flowcont_Write_Data1:
;mmb_3_fpi_stm32.h,146 :: 		Write_to_Data_Lines_8bit(temp);
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
BL	flowcont_Write_to_Data_Lines_8bit+0
;mmb_3_fpi_stm32.h,147 :: 		temp = (_data<<3);
LSLS	R1, R3, #3
; _data end address is: 12 (R3)
; temp start address is: 12 (R3)
UXTB	R3, R1
;mmb_3_fpi_stm32.h,149 :: 		if ((temp>>7) == 1)
LSRS	R1, R3, #7
UXTB	R1, R1
CMP	R1, #1
IT	NE
BNE	L_flowcont_Write_Data19
;mmb_3_fpi_stm32.h,151 :: 		temp += 7;
ADDS	R1, R3, #7
; temp end address is: 12 (R3)
; temp start address is: 0 (R0)
UXTB	R0, R1
; temp end address is: 0 (R0)
;mmb_3_fpi_stm32.h,152 :: 		}
IT	AL
BAL	L_flowcont_Write_Data2
L_flowcont_Write_Data19:
;mmb_3_fpi_stm32.h,149 :: 		if ((temp>>7) == 1)
UXTB	R0, R3
;mmb_3_fpi_stm32.h,152 :: 		}
L_flowcont_Write_Data2:
;mmb_3_fpi_stm32.h,154 :: 		Write_to_Data_Lines_8bit(temp);
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
BL	flowcont_Write_to_Data_Lines_8bit+0
;mmb_3_fpi_stm32.h,155 :: 		}
L_end_Write_Data:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of flowcont_Write_Data
flowcont_hal_display_init:
;mmb_3_fpi_stm32.h,157 :: 		static void hal_display_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,161 :: 		TFT_Set_Active( Set_Index, Write_Command, Write_Data );
MOVW	R2, #lo_addr(flowcont_Write_Data+0)
MOVT	R2, #hi_addr(flowcont_Write_Data+0)
MOVW	R1, #lo_addr(flowcont_Write_Command+0)
MOVT	R1, #hi_addr(flowcont_Write_Command+0)
MOVW	R0, #lo_addr(flowcont_Set_Index+0)
MOVT	R0, #hi_addr(flowcont_Set_Index+0)
BL	_TFT_Set_Active+0
;mmb_3_fpi_stm32.h,162 :: 		TFT_Init_SSD1963_Board_35( 320, 240 );
MOVS	R1, #240
MOVW	R0, #320
BL	_TFT_Init_SSD1963_Board_35+0
;mmb_3_fpi_stm32.h,163 :: 		TFT_Set_DBC_SSD1963( 255 );
MOVS	R0, #255
BL	_TFT_Set_DBC_SSD1963+0
;mmb_3_fpi_stm32.h,164 :: 		}
L_end_hal_display_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of flowcont_hal_display_init
flowcont_hal_touch_init:
;mmb_3_fpi_stm32.h,172 :: 		static uint8_t hal_touch_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,176 :: 		GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_6 );
MOVW	R1, #64
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_3_fpi_stm32.h,177 :: 		GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_7 );
MOVW	R1, #128
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_3_fpi_stm32.h,179 :: 		GPIOB_ODR.B6 = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
_SX	[R0, ByteOffset(GPIOB_ODR+0)]
;mmb_3_fpi_stm32.h,181 :: 		while ( GPIOB_IDR.B7 == 0 )
L_flowcont_hal_touch_init3:
MOVW	R0, #lo_addr(GPIOB_IDR+0)
MOVT	R0, #hi_addr(GPIOB_IDR+0)
_LX	[R0, ByteOffset(GPIOB_IDR+0)]
CMP	R0, #0
IT	NE
BNE	L_flowcont_hal_touch_init4
;mmb_3_fpi_stm32.h,183 :: 		GPIOB_ODR.B6 = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
_SX	[R0, ByteOffset(GPIOB_ODR+0)]
;mmb_3_fpi_stm32.h,184 :: 		Delay_us( 10 );
MOVW	R7, #398
MOVT	R7, #0
NOP
NOP
L_flowcont_hal_touch_init5:
SUBS	R7, R7, #1
BNE	L_flowcont_hal_touch_init5
NOP
NOP
NOP
;mmb_3_fpi_stm32.h,185 :: 		GPIOB_ODR.B6 = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOB_ODR+0)
MOVT	R0, #hi_addr(GPIOB_ODR+0)
_SX	[R0, ByteOffset(GPIOB_ODR+0)]
;mmb_3_fpi_stm32.h,186 :: 		Delay_us( 10 );
MOVW	R7, #398
MOVT	R7, #0
NOP
NOP
L_flowcont_hal_touch_init7:
SUBS	R7, R7, #1
BNE	L_flowcont_hal_touch_init7
NOP
NOP
NOP
;mmb_3_fpi_stm32.h,187 :: 		}
IT	AL
BAL	L_flowcont_hal_touch_init3
L_flowcont_hal_touch_init4:
;mmb_3_fpi_stm32.h,189 :: 		I2C1_Init_Advanced( 400000, &_GPIO_MODULE_I2C1_PB67 );
MOVW	R1, #lo_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVT	R1, #hi_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVW	R0, #6784
MOVT	R0, #6
BL	_I2C1_Init_Advanced+0
;mmb_3_fpi_stm32.h,191 :: 		FT5XX6_SetI2CAddress( 0x38 );
MOVS	R0, #56
BL	_FT5XX6_SetI2CAddress+0
;mmb_3_fpi_stm32.h,193 :: 		if ( FT5XX6_IsOperational( ) != FT5XX6_OK )
BL	_FT5XX6_IsOperational+0
CMP	R0, #0
IT	EQ
BEQ	L_flowcont_hal_touch_init9
;mmb_3_fpi_stm32.h,195 :: 		return FT5XX6_FAILURE;
MOVS	R0, #1
IT	AL
BAL	L_end_hal_touch_init
;mmb_3_fpi_stm32.h,196 :: 		}
L_flowcont_hal_touch_init9:
;mmb_3_fpi_stm32.h,198 :: 		FT5XX6_SetDefaultMode( );
BL	_FT5XX6_SetDefaultMode+0
;mmb_3_fpi_stm32.h,199 :: 		FT5XX6_SetController( _TC_FT5X26 );
MOVS	R0, #3
BL	_FT5XX6_SetController+0
;mmb_3_fpi_stm32.h,200 :: 		FT5XX6_SetSizeAndRotation( 320, 240, 2 );
MOVS	R2, #2
MOVS	R1, #240
MOVW	R0, #320
BL	_FT5XX6_SetSizeAndRotation+0
;mmb_3_fpi_stm32.h,202 :: 		return FT5XX6_OK;
MOVS	R0, #0
;mmb_3_fpi_stm32.h,203 :: 		}
L_end_hal_touch_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of flowcont_hal_touch_init
flowcont_hal_console_init:
;mmb_3_fpi_stm32.h,215 :: 		static void hal_console_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,224 :: 		&_GPIO_MODULE_USART2_PD5_PA3
MOVW	R0, #lo_addr(__GPIO_MODULE_USART2_PD5_PA3+0)
MOVT	R0, #hi_addr(__GPIO_MODULE_USART2_PD5_PA3+0)
PUSH	(R0)
;mmb_3_fpi_stm32.h,223 :: 		_UART_ONE_STOPBIT,
MOVW	R3, #0
;mmb_3_fpi_stm32.h,222 :: 		_UART_NOPARITY,
MOVW	R2, #0
;mmb_3_fpi_stm32.h,221 :: 		_UART_8_BIT_DATA,
MOVW	R1, #0
;mmb_3_fpi_stm32.h,220 :: 		115200,
MOV	R0, #115200
;mmb_3_fpi_stm32.h,224 :: 		&_GPIO_MODULE_USART2_PD5_PA3
BL	_UART2_Init_Advanced+0
ADD	SP, SP, #4
;mmb_3_fpi_stm32.h,226 :: 		}
L_end_hal_console_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of flowcont_hal_console_init
flowcont_hal_power_init:
;mmb_3_fpi_stm32.h,259 :: 		static void hal_power_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,267 :: 		GPIO_Digital_Input( &GPIOH_BASE, _GPIO_PINMASK_0 );
MOVW	R1, #1
MOVW	R0, #lo_addr(GPIOH_BASE+0)
MOVT	R0, #hi_addr(GPIOH_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_3_fpi_stm32.h,270 :: 		GPIO_Analog_Input( &GPIOA_BASE, _GPIO_PINMASK_0 );
MOVW	R1, #1
MOVW	R0, #lo_addr(GPIOA_BASE+0)
MOVT	R0, #hi_addr(GPIOA_BASE+0)
BL	_GPIO_Analog_Input+0
;mmb_3_fpi_stm32.h,271 :: 		ADC_Set_Input_Channel( _ADC_CHANNEL_0 );
MOVW	R0, #1
BL	_ADC_Set_Input_Channel+0
;mmb_3_fpi_stm32.h,272 :: 		ADC2_Init( );
BL	_ADC2_Init+0
;mmb_3_fpi_stm32.h,273 :: 		}
L_end_hal_power_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of flowcont_hal_power_init
flowcont_hal_microsd_init:
;mmb_3_fpi_stm32.h,291 :: 		static void hal_microsd_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,314 :: 		GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_3 );   // SD_CD
MOVW	R1, #8
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_3_fpi_stm32.h,315 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_2 );  // SD_CMD
MOVW	R1, #4
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_3_fpi_stm32.h,317 :: 		SDIO_Reset( );
BL	_SDIO_Reset+0
;mmb_3_fpi_stm32.h,320 :: 		| _SDIO_CFG_CLOCK_RISING_EDGE  | _SDIO_CFG_HW_FLOW_DISABLE, 125, &_GPIO_MODULE_SDIO_D0_D3 );
MOVW	R2, #lo_addr(__GPIO_MODULE_SDIO_D0_D3+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SDIO_D0_D3+0)
MOVS	R1, #125
MOV	R0, #2048
BL	_SDIO_Init+0
;mmb_3_fpi_stm32.h,323 :: 		GPIOD_PUPDRbits.PUPDR2  = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOD_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOD_PUPDRbits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #4, #2
STRB	R0, [R1, #0]
;mmb_3_fpi_stm32.h,324 :: 		GPIOD_PUPDRbits.PUPDR3  = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOD_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOD_PUPDRbits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #6, #2
STRB	R0, [R1, #0]
;mmb_3_fpi_stm32.h,325 :: 		GPIOC_PUPDRbits.PUPDR8  = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #16, #2
STR	R0, [R1, #0]
;mmb_3_fpi_stm32.h,326 :: 		GPIOC_PUPDRbits.PUPDR9  = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #18, #2
STR	R0, [R1, #0]
;mmb_3_fpi_stm32.h,327 :: 		GPIOC_PUPDRbits.PUPDR10 = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #20, #2
STR	R0, [R1, #0]
;mmb_3_fpi_stm32.h,328 :: 		GPIOC_PUPDRbits.PUPDR11 = 1;
MOVS	R2, #1
MOVW	R1, #lo_addr(GPIOC_PUPDRbits+0)
MOVT	R1, #hi_addr(GPIOC_PUPDRbits+0)
LDR	R0, [R1, #0]
BFI	R0, R2, #22, #2
STR	R0, [R1, #0]
;mmb_3_fpi_stm32.h,330 :: 		Mmc_Set_Interface( _MMC_INTERFACE_SDIO );
MOVS	R0, #1
BL	_Mmc_Set_Interface+0
;mmb_3_fpi_stm32.h,333 :: 		}
L_end_hal_microsd_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of flowcont_hal_microsd_init
flowcont_hal_flash_init:
;mmb_3_fpi_stm32.h,351 :: 		static void hal_flash_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,355 :: 		GPIO_Digital_Output( &GPIOE_BASE, _GPIO_PINMASK_8 );
MOVW	R1, #256
MOVW	R0, #lo_addr(GPIOE_BASE+0)
MOVT	R0, #hi_addr(GPIOE_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_3_fpi_stm32.h,369 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
MOVW	R2, #lo_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SPI2_PB13_14_15+0)
;mmb_3_fpi_stm32.h,368 :: 		_SPI_SSI_1,
MOVW	R1, #772
;mmb_3_fpi_stm32.h,360 :: 		_SPI_FPCLK_DIV64,
MOVS	R0, #5
;mmb_3_fpi_stm32.h,369 :: 		&_GPIO_MODULE_SPI2_PB13_14_15
BL	_SPI2_Init_Advanced+0
;mmb_3_fpi_stm32.h,372 :: 		BSP_FLASH_CE = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOE_ODR+0)
MOVT	R0, #hi_addr(GPIOE_ODR+0)
_SX	[R0, ByteOffset(GPIOE_ODR+0)]
;mmb_3_fpi_stm32.h,373 :: 		}
L_end_hal_flash_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of flowcont_hal_flash_init
flowcont_hal_mp3_init:
;mmb_3_fpi_stm32.h,500 :: 		static void hal_mp3_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,504 :: 		GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_9 );
MOVW	R1, #512
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_3_fpi_stm32.h,508 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_11 );
MOVW	R1, #2048
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_3_fpi_stm32.h,512 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_8 );
MOVW	R1, #256
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_3_fpi_stm32.h,516 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_10 );
MOVW	R1, #1024
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_3_fpi_stm32.h,520 :: 		BSP_MP3_CS            = 1;               // Deselect MP3_CS
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;mmb_3_fpi_stm32.h,521 :: 		BSP_MP3_RST           = 1;               // Set MP3_RST pin
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;mmb_3_fpi_stm32.h,522 :: 		BSP_MP3_DCS           = 1;               // Clear BSYNC
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;mmb_3_fpi_stm32.h,534 :: 		&_GPIO_MODULE_SPI1_PA567);
MOVW	R2, #lo_addr(__GPIO_MODULE_SPI1_PA567+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SPI1_PA567+0)
;mmb_3_fpi_stm32.h,533 :: 		| _SPI_SSI_1,
MOVW	R1, #772
;mmb_3_fpi_stm32.h,525 :: 		SPI1_Init_Advanced( _SPI_FPCLK_DIV64,
MOVS	R0, #5
;mmb_3_fpi_stm32.h,534 :: 		&_GPIO_MODULE_SPI1_PA567);
BL	_SPI1_Init_Advanced+0
;mmb_3_fpi_stm32.h,535 :: 		}
L_end_hal_mp3_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of flowcont_hal_mp3_init
flowcont_hal_accel_init:
;mmb_3_fpi_stm32.h,555 :: 		static void hal_accel_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,559 :: 		GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_9 );
MOVW	R1, #512
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_3_fpi_stm32.h,563 :: 		GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_8 );
MOVW	R1, #256
MOVW	R0, #lo_addr(GPIOB_BASE+0)
MOVT	R0, #hi_addr(GPIOB_BASE+0)
BL	_GPIO_Digital_Input+0
;mmb_3_fpi_stm32.h,567 :: 		I2C1_Init_Advanced( 100000, &_GPIO_MODULE_I2C1_PB67 );
MOVW	R1, #lo_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVT	R1, #hi_addr(__GPIO_MODULE_I2C1_PB67+0)
MOVW	R0, #34464
MOVT	R0, #1
BL	_I2C1_Init_Advanced+0
;mmb_3_fpi_stm32.h,568 :: 		}
L_end_hal_accel_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of flowcont_hal_accel_init
flowcont_hal_rtc_init:
;mmb_3_fpi_stm32.h,722 :: 		static void hal_rtc_init ( void )
;mmb_3_fpi_stm32.h,728 :: 		RCC_APB1ENR.B28 = 1;  // Enable the PWR clock
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(RCC_APB1ENR+0)
MOVT	R0, #hi_addr(RCC_APB1ENR+0)
_SX	[R0, ByteOffset(RCC_APB1ENR+0)]
;mmb_3_fpi_stm32.h,729 :: 		if (RCC_BDCR.RTCEN == 0){         // if RTC is disabled ...
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
_LX	[R0, ByteOffset(RCC_BDCR+0)]
CMP	R0, #0
IT	NE
BNE	L_flowcont_hal_rtc_init10
;mmb_3_fpi_stm32.h,730 :: 		PWR_CR.DBP = 1;                 // Allow access to RTC
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(PWR_CR+0)
MOVT	R0, #hi_addr(PWR_CR+0)
_SX	[R0, ByteOffset(PWR_CR+0)]
;mmb_3_fpi_stm32.h,732 :: 		RTC_WPR = 0xCA;                 //unlock write protection
MOVS	R1, #202
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;mmb_3_fpi_stm32.h,733 :: 		RTC_WPR = 0x53;                 //unlock write protection
MOVS	R1, #83
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;mmb_3_fpi_stm32.h,734 :: 		RCC_CSR = 0x00000000ul;
MOV	R1, #0
MOVW	R0, #lo_addr(RCC_CSR+0)
MOVT	R0, #hi_addr(RCC_CSR+0)
STR	R1, [R0, #0]
;mmb_3_fpi_stm32.h,735 :: 		RCC_BDCR = 0x8101u;          // RTCEN = 1, LSE, LSEON
MOVW	R1, #33025
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
STR	R1, [R0, #0]
;mmb_3_fpi_stm32.h,736 :: 		RTC_CR |= 0x00880000ul;
MOVW	R0, #lo_addr(RTC_CR+0)
MOVT	R0, #hi_addr(RTC_CR+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #8912896
MOVW	R0, #lo_addr(RTC_CR+0)
MOVT	R0, #hi_addr(RTC_CR+0)
STR	R1, [R0, #0]
;mmb_3_fpi_stm32.h,737 :: 		}
L_flowcont_hal_rtc_init10:
;mmb_3_fpi_stm32.h,738 :: 		while(RTC_ISR.B5 != 1){}         // Wait for RTC APB registers synchronisation
L_flowcont_hal_rtc_init11:
MOVW	R0, #lo_addr(RTC_ISR+0)
MOVT	R0, #hi_addr(RTC_ISR+0)
_LX	[R0, ByteOffset(RTC_ISR+0)]
CMP	R0, #0
IT	NE
BNE	L_flowcont_hal_rtc_init12
IT	AL
BAL	L_flowcont_hal_rtc_init11
L_flowcont_hal_rtc_init12:
;mmb_3_fpi_stm32.h,740 :: 		while(RCC_BDCR.LSERDY != 1){};    // Wait till LSE is ready
L_flowcont_hal_rtc_init13:
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
_LX	[R0, ByteOffset(RCC_BDCR+0)]
CMP	R0, #0
IT	NE
BNE	L_flowcont_hal_rtc_init14
IT	AL
BAL	L_flowcont_hal_rtc_init13
L_flowcont_hal_rtc_init14:
;mmb_3_fpi_stm32.h,743 :: 		RTC_WPR = 0xFF;
MOVS	R1, #255
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;mmb_3_fpi_stm32.h,745 :: 		}
L_end_hal_rtc_init:
BX	LR
; end of flowcont_hal_rtc_init
flowcont_hal_usb_init:
;mmb_3_fpi_stm32.h,759 :: 		static void hal_usb_init ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;mmb_3_fpi_stm32.h,763 :: 		GPIO_Alternate_Function_Enable( &_GPIO_MODULE_OTG_FS_PA89_10_11_12 );
MOVW	R0, #lo_addr(__GPIO_MODULE_OTG_FS_PA89_10_11_12+0)
MOVT	R0, #hi_addr(__GPIO_MODULE_OTG_FS_PA89_10_11_12+0)
BL	_GPIO_Alternate_Function_Enable+0
;mmb_3_fpi_stm32.h,767 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_6 );
MOVW	R1, #64
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;mmb_3_fpi_stm32.h,771 :: 		BSP_USB_PSW = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;mmb_3_fpi_stm32.h,772 :: 		Delay_ms( 100 );
MOVW	R7, #2302
MOVT	R7, #61
NOP
NOP
L_flowcont_hal_usb_init15:
SUBS	R7, R7, #1
BNE	L_flowcont_hal_usb_init15
NOP
NOP
NOP
;mmb_3_fpi_stm32.h,773 :: 		BSP_USB_PSW = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
_SX	[R0, ByteOffset(GPIOD_ODR+0)]
;mmb_3_fpi_stm32.h,774 :: 		}
L_end_hal_usb_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of flowcont_hal_usb_init
