#line 1 "D:/Test Procedure/Mikromedije/STM32/mikromedia 3 FPI for STM32 CAPACITIVE/SW/mikromedia-sdk/test/modules/ethernet_test.c"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/mikromedia-sdk/test/test_types.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"



typedef long ptrdiff_t;


 typedef unsigned long size_t;

typedef unsigned long wchar_t;
#line 40 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/mikromedia-sdk/test/test_types.h"
typedef enum
{
 TEST_PREINIT,
 TEST_INIT,
 TEST_TASK

} test_step_t;

typedef struct
{
 test_step_t step;
 uint16_t delay;
 uint8_t name[16];

} test_param_t;

typedef void ( * test_procedure )( test_param_t * );
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/mikromedia-sdk/test/console/test_console.h"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/portable/bsp.h"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/mikromedia-sdk/bsp/mmb.h"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/mikromedia-sdk/bsp/mmb_3_fpi.h"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/portable/mmb_3_fpi_stm32.h"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/mikromedia-sdk/compiler/compiler.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/mikromedia-sdk/compiler/mikroc_arm.h"
#line 41 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/mikromedia-sdk/compiler/mikroc_arm.h"
typedef void ( * hal_spi_write_fp_t ) ( unsigned int );
typedef unsigned int ( * hal_spi_read_fp_t ) ( unsigned int );

typedef struct
{
 hal_spi_write_fp_t spi_write;
 hal_spi_read_fp_t spi_read;

} hal_spi_obj_t;

typedef unsigned int ( * hal_i2c_start_fp_t ) ( void );
typedef unsigned int ( * hal_i2c_write_fp_t ) ( unsigned char, unsigned char *, unsigned long, unsigned long );
typedef void ( * hal_i2c_read_fp_t ) ( unsigned char, unsigned char *, unsigned long, unsigned long );

typedef struct
{
 hal_i2c_start_fp_t i2c_start;
 hal_i2c_write_fp_t i2c_write;
 hal_i2c_read_fp_t i2c_read;

} hal_i2c_obj_t;

typedef void ( * hal_uart_write_fp_t ) ( unsigned int );
typedef unsigned int ( * hal_uart_read_fp_t ) ( void );
typedef unsigned int ( * hal_uart_ready_fp_t ) ( void );

typedef struct
{
 hal_uart_write_fp_t uart_write;
 hal_uart_read_fp_t uart_read;
 hal_uart_ready_fp_t uart_ready;

} hal_uart_obj_t;

typedef void ( * hal_pwm_duty_fp_t ) ( unsigned int, char, char );

typedef void ( * hal_pwm_stop_fp_t ) ( char );

typedef struct
{
 hal_pwm_duty_fp_t pwm_duty;

 hal_pwm_stop_fp_t pwm_stop;

} hal_pwm_obj_t;

typedef unsigned int ( * hal_adc_read_fp_t ) ( unsigned int );
typedef unsigned int ( * hal_adc_sample_fp_t ) ( unsigned int );

typedef struct
{
 hal_adc_read_fp_t adc_read;
 hal_adc_sample_fp_t adc_sample;

} hal_adc_obj_t;
#line 79 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/portable/mmb_3_fpi_stm32.h"
extern sfr sbit TFT_BLED;
extern sfr sbit TFT_CS;
extern sfr sbit TFT_RD;
extern sfr sbit TFT_RS;
extern sfr sbit TFT_RST;
extern sfr sbit TFT_WR;

static void Write_to_Data_Lines ( unsigned char _hi, unsigned char _lo )
{
 unsigned int tmp = GPIOE_ODR;
 tmp &= 0xFF00;
 GPIOE_ODR = tmp | _hi;
 tmp = GPIOE_ODR;
 tmp &= 0xFF00;
 GPIOE_ODR = tmp | _lo;
}

static void Write_to_Data_Lines_8bit ( unsigned char _data )
{
 unsigned int tmp = GPIOE_ODR;
 tmp &= 0xFF00;
 GPIOE_ODR = tmp | _data;
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

static void Set_Index ( unsigned short index )
{
 TFT_RS = 0;
 Write_to_Data_Lines(0, index);
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

static void Write_Command ( unsigned short cmd )
 {
 TFT_RS = 1;
 Write_to_Data_Lines(0, cmd);
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

static void Write_Data ( unsigned int _data )
{
 volatile unsigned short temp;

 TFT_RS = 1;
 temp = (_data>>11);
 temp = (temp<<3);

 if ((temp>>7) == 1)
 {
 temp += 7;
 }

 Write_to_Data_Lines_8bit(temp);
 temp = (_data>>5);
 temp = (temp<<2);

 if ((temp>>7) == 1)
 {
 temp += 3;
 }

 Write_to_Data_Lines_8bit(temp);
 temp = (_data<<3);

 if ((temp>>7) == 1)
 {
 temp += 7;
 }

 Write_to_Data_Lines_8bit(temp);
}

static void hal_display_init ( void )
{


 TFT_Set_Active( Set_Index, Write_Command, Write_Data );
 TFT_Init_SSD1963_Board_35( 320, 240 );
 TFT_Set_DBC_SSD1963( 255 );
}







static uint8_t hal_touch_init ( void )
{


 GPIO_Digital_Output( &GPIOB_BASE, _GPIO_PINMASK_6 );
 GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_7 );

 GPIOB_ODR.B6 = 1;

 while ( GPIOB_IDR.B7 == 0 )
 {
 GPIOB_ODR.B6 = 0;
 Delay_us( 10 );
 GPIOB_ODR.B6 = 1;
 Delay_us( 10 );
 }

 I2C1_Init_Advanced( 400000, &_GPIO_MODULE_I2C1_PB67 );

 FT5XX6_SetI2CAddress( 0x38 );

 if ( FT5XX6_IsOperational( ) != FT5XX6_OK )
 {
 return FT5XX6_FAILURE;
 }

 FT5XX6_SetDefaultMode( );
 FT5XX6_SetController( _TC_FT5X26 );
 FT5XX6_SetSizeAndRotation( 320, 240, 2 );

 return FT5XX6_OK;
}
#line 215 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/portable/mmb_3_fpi_stm32.h"
static void hal_console_init ( void )
{


 UART2_Init_Advanced(
 115200,
 _UART_8_BIT_DATA,
 _UART_NOPARITY,
 _UART_ONE_STOPBIT,
 &_GPIO_MODULE_USART2_PD5_PA3
 );
}
#line 240 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/portable/mmb_3_fpi_stm32.h"
static sbit BSP_CHARGER_STATUS at GPIOH_IDR.B0;
#line 253 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/portable/mmb_3_fpi_stm32.h"
const static hal_adc_obj_t BSP_POWER_ADC_MODULE =
{
 ADC2_Read,
 ADC2_Get_Sample
};

static void hal_power_init ( void )
{






 GPIO_Digital_Input( &GPIOH_BASE, _GPIO_PINMASK_0 );


 GPIO_Analog_Input( &GPIOA_BASE, _GPIO_PINMASK_0 );
 ADC_Set_Input_Channel( _ADC_CHANNEL_0 );
 ADC2_Init( );
}
#line 291 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/portable/mmb_3_fpi_stm32.h"
static void hal_microsd_init ( void )
{
#line 314 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/portable/mmb_3_fpi_stm32.h"
 GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_3 );
 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_2 );

 SDIO_Reset( );

 SDIO_Init( _SDIO_CFG_POWER_SAVE_DISABLE | _SDIO_CFG_4_WIDE_BUS_MODE | _SDIO_CFG_CLOCK_BYPASS_DISABLE
 | _SDIO_CFG_CLOCK_RISING_EDGE | _SDIO_CFG_HW_FLOW_DISABLE, 125, &_GPIO_MODULE_SDIO_D0_D3 );


 GPIOD_PUPDRbits.PUPDR2 = 1;
 GPIOD_PUPDRbits.PUPDR3 = 1;
 GPIOC_PUPDRbits.PUPDR8 = 1;
 GPIOC_PUPDRbits.PUPDR9 = 1;
 GPIOC_PUPDRbits.PUPDR10 = 1;
 GPIOC_PUPDRbits.PUPDR11 = 1;

 Mmc_Set_Interface( _MMC_INTERFACE_SDIO );


}









static sbit BSP_FLASH_CE at GPIOE_ODR.B8;

const static hal_spi_obj_t BSP_FLASH_SPI_MODULE =
{
 SPI2_Write,
 SPI2_Read
};

static void hal_flash_init ( void )
{


 GPIO_Digital_Output( &GPIOE_BASE, _GPIO_PINMASK_8 );



 SPI2_Init_Advanced(
 _SPI_FPCLK_DIV64,
 _SPI_MASTER |
 _SPI_8_BIT |
 _SPI_CLK_IDLE_LOW |
 _SPI_FIRST_CLK_EDGE_TRANSITION |
 _SPI_MSB_FIRST |
 _SPI_SS_DISABLE |
 _SPI_SSM_ENABLE |
 _SPI_SSI_1,
 &_GPIO_MODULE_SPI2_PB13_14_15
 );

 BSP_FLASH_CE = 1;
}
#line 489 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/portable/mmb_3_fpi_stm32.h"
static volatile sbit BSP_MP3_DREQ at GPIOD_IDR.B9;
static volatile sbit BSP_MP3_CS at GPIOD_ODR.B11;
static volatile sbit BSP_MP3_RST at GPIOD_ODR.B8;
static volatile sbit BSP_MP3_DCS at GPIOD_ODR.B10;

static const hal_spi_obj_t BSP_MP3_SPI_MODULE =
{
 SPI1_Write,
 SPI1_Read
};

static void hal_mp3_init ( void )
{


 GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_9 );



 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_11 );



 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_8 );



 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_10 );



 BSP_MP3_CS = 1;
 BSP_MP3_RST = 1;
 BSP_MP3_DCS = 1;


 SPI1_Init_Advanced( _SPI_FPCLK_DIV64,
 _SPI_MASTER
 | _SPI_8_BIT
 | _SPI_CLK_IDLE_LOW
 | _SPI_FIRST_CLK_EDGE_TRANSITION
 | _SPI_MSB_FIRST
 | _SPI_SS_DISABLE
 | _SPI_SSM_ENABLE
 | _SPI_SSI_1,
 &_GPIO_MODULE_SPI1_PA567);
}









static sbit BSP_ACCEL_INT_1 at GPIOB_IDR.B9;
static sbit BSP_ACCEL_INT_2 at GPIOB_IDR.B8;

const static hal_i2c_obj_t BSP_ACCEL_I2C_MODULE =
{
 I2C1_Start,
 I2C1_Write,
 I2C1_Read
};

static void hal_accel_init ( void )
{


 GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_9 );



 GPIO_Digital_Input( &GPIOB_BASE, _GPIO_PINMASK_8 );



 I2C1_Init_Advanced( 100000, &_GPIO_MODULE_I2C1_PB67 );
}
#line 722 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/portable/mmb_3_fpi_stm32.h"
static void hal_rtc_init ( void )
{




 RCC_APB1ENR.B28 = 1;
 if (RCC_BDCR.RTCEN == 0){
 PWR_CR.DBP = 1;

 RTC_WPR = 0xCA;
 RTC_WPR = 0x53;
 RCC_CSR = 0x00000000ul;
 RCC_BDCR = 0x8101u;
 RTC_CR |= 0x00880000ul;
 }
 while(RTC_ISR.B5 != 1){}

 while(RCC_BDCR.LSERDY != 1){};


 RTC_WPR = 0xFF;

}
#line 757 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/portable/mmb_3_fpi_stm32.h"
static sbit BSP_USB_PSW at GPIOD_ODR.B6;

static void hal_usb_init ( void )
{


 GPIO_Alternate_Function_Enable( &_GPIO_MODULE_OTG_FS_PA89_10_11_12 );



 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_6 );



 BSP_USB_PSW = 1;
 Delay_ms( 100 );
 BSP_USB_PSW = 0;
}
#line 88 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/mikromedia-sdk/test/console/test_console.h"
typedef enum
{
 HEX_FORMAT,
 BYTE_FORMAT,
 SIGNED_WORD_FORMAT,
 UNSIGNED_WORD_FORMAT,
 SIGNED_LONG_FORMAT,
 UNSIGNED_LONG_FORMAT,
 FLOAT_FORMAT,
 STRING_FORMAT

} data_format_t;



void test_console_write_text ( uint8_t * x );

void test_console_write_line ( uint8_t * x );

uint8_t test_console_read ( void );

void test_console_init ( void );

void test_sequence_start ( void );

void test_sequence_finish ( void );

void test_console_header ( uint8_t * desc );

void test_console_sub_header ( uint8_t * desc, uint8_t * info );

void test_console_operation ( uint8_t step, uint8_t * desc );

void test_console_output ( uint8_t * desc, void * output, data_format_t fmt, uint8_t * fin );
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/mikromedia-sdk/test/resources/test_server_page.h"




static const unsigned char HTTP_GET_METHOD [ ] =
"GET /";

static const unsigned char HTTP_HEADER [ ] =
"HTTP/1.1 200 OK\nContent-type: ";

static const unsigned char HTTP_MIME_HTML_TYPE [ ] =
"text/html\n\n";

static const unsigned char HTTP_WEB_PAGE [ ] =
"<HTML><HEAD></HEAD><BODY><h1>Embedded Web Server</h1></BODY>";
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/mikromedia-sdk/driver/bsp_ethernet_driver.h"
#line 1 "d:/test procedure/mikromedije/stm32/mikromedia 3 fpi for stm32 capacitive/sw/portable/bsp.h"
